package asgaard.skid;

import java.rmi.*;

/**
 * This Class is a simple RMI-Ping to check whether Skid is alive or not.
 */
public class Ping {

	protected RemoteBroker skid;

  /**
   * Main-Methode
   */
  public static void main(String[] args) {
    System.out.println("Hello, this is SkidPing, checking Skid-RMI connection.");
    System.out.println("Usage: java asgaard.skid.Ping <host>");
    if (args.length < 1) {
      System.out.println("parameter missing: e.g. host.somedomain or 128.130.167.57");
      System.exit( 0 );
    }
    Ping app = new Ping();
    app.ping(args[0]);
  }

  /**
   * Doing the ping
   */
  public void ping(String host) {
    try {
			skid = (RemoteBroker) Naming.lookup("//" + host +"/"+ Skid.ServerName);
      BeanBroker.THIS = skid;
      BeanBroker.HOST = host;
    } catch (Exception e) {
      System.out.println("Could not connect to //" + host + "/" + Skid.ServerName);
      System.out.println(e.toString());
      e.printStackTrace();
      System.exit( 0 );
    }
    System.out.println("Connect to //" + host +"/"+ Skid.ServerName);
  }

}

