// This class is part of Skid
//@autor  (P) by Klaus Hammermller, mailto:klaus@ifs.tuwien.ac.at
//@version	    1.0
//@created	    310398  KH
//@modified	    220598  KH  FIX bei SetBeanKey, IMAGE->TEXT (Workaround)
//@modified     070399  KH  use of SQLRes resource File for SQL-Statements
package asgaard.skid;
// Import the JDBC classes
import java.sql.*;

// Import the java classes used in applets
import java.util.*;
import java.io.*;
// Import Oracle SQLJ
//import oracle.sqlj.runtime.Oracle;

// Import SkidAPI
import asgaard.skid.*;

    /**
     * SkidSetup is the creation-routine if only an empty or damaged database is
     * available. The creation of all nessecary Datastructures is transparently encapsulated
     * for automated use by the <code>BeanBroker</code>.
     *@see asgaard.skid.SkidBroker
     */
public class SkidSetup {

    private static boolean debug = true;

  /**
   * Creates a Setup-Object for processing an automated setup.
   * Creates all datastructures physuically new, Errormessages are passed through.
   *@param sres collection of SQL-Statements
   *@param  conn the (opened) connection
   *@exception SQLException
   */
  public static void createDataBase ( ResourceBundle sres, Connection conn ) throws SQLException {
    String s;
    Vector createScript = new Vector(10, 10);

    // Es fehlt CREATE DATABASE und DROP DATABASE - nur bei SQL Server mglich//       Nach Neuerlichen Setup mu sich der Client zertifizieren (SetBeanKey)

    // KEY
    s = sres.getString("dateFormat");           if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropCKEY");             if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createCKEY");           if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("insertCKEY");           if (! s.equals("")) createScript.addElement( s );
    // BEAN
    s = sres.getString("dropUSER");             if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createUSER");           if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("insertUSER");           if (! s.equals("")) createScript.addElement( s );
    // BEAN
    s = sres.getString("dropBean");             if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createBean");           if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("insertBean");           if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropInsertBean");       if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createInsertBean");     if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropUpdateBean");       if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createUpdateBean");     if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropSelectBean");       if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createSelectBean");     if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropSelectClass");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createSelectClass");    if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropInsertClass");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createInsertClass");    if (! s.equals("")) createScript.addElement( s );
    // LINKS
    s = sres.getString("dropLINK");             if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createLINK");           if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropInsertLink");       if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createInsertLink");     if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropUpdateLink");       if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createUpdateLink");     if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropSelectLink");       if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createSelectLink");     if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropSelectLink2");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createSelectLink2");    if (! s.equals("")) createScript.addElement( s );
    // KEYS
    s = sres.getString("dropCreateKey");        if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createCreateKey");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropInsertKey");        if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createInsertKey");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropDeleteKey");        if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createDeleteKey");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropSelectKey");        if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createSelectKey");      if (! s.equals("")) createScript.addElement( s );
    // EVENTS
    s = sres.getString("dropEVENT");            if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createEVENT");          if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropInsertEvent");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createInsertEvent");    if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropDeleteEvent");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createDeleteEvent");    if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("dropSelectEvent");      if (! s.equals("")) createScript.addElement( s );
    s = sres.getString("createSelectEvent");    if (! s.equals("")) createScript.addElement( s );

	  Statement stmt = conn.createStatement ();	      // create a statement

	  for ( int i=0; i < createScript.size(); ++i ) {	// does the script
	    try {
        String aStmt = (String) createScript.elementAt( i );
		    Skid.out("SQL>", aStmt);
        StringTokenizer tokens = new StringTokenizer( aStmt, "\n", false );
		    while (tokens.hasMoreTokens())
		      stmt.executeQuery ( tokens.nextToken() );
	    } catch (Exception e) {			                  // Oops
 		    Skid.out("error", e.toString() + " " + e.getMessage ());
        if (debug) e.printStackTrace();
	    }
	  }
  }

}
