package asgaard.skid;

import java.rmi.*;
import asgaard.utils.test.*;
import asgaard.utils.unit.*;

/**
 * This Class is a the Test-class for the asgaard.skid package.
 */
public class TestSkid extends Test {

    private static Integer i0 = new Integer(0);

    public final static Object[][] TESTSCRIPT_BEANBROKER_INTERFACE = {
      { TEST_METHOD, "newDef#1", "asgaard.lang.Def", null, new Object[] {"Def X ShortName", "Def X LongName"} },
      { TEST_METHOD, "savDef#1", RES_OBJ+"newDef#1", "flush", null },
      { TEST_METHOD, "getDefKey#1", RES_OBJ+"newDef#1", "getKey", null },
      { TEST_METHOD, "newWord#1", "asgaard.lang.Word", null, new Object[] {"Word Y ShortName", "Word Y LongName"} },
      { TEST_METHOD, "setWord#1", RES_OBJ+"newWord#1", "setName", new Object[] { RES_OBJ+"getDefKey#1", "Word Y ShortAddon", "Word Y LongAddon" }, new String[] {"int", "java.lang.String", "java.lang.String"} },
      { TEST_METHOD, "savWord#1", RES_OBJ+"newWord#1", "flush", null },
      { TEST_METHOD, "modWord#1.1", RES_OBJ+"newWord#1", "setName", new Object[] { RES_OBJ+"getDefKey#1", "Word Y ShortModification", "Word Y LongModification" }, new String[] {"int", "java.lang.String", "java.lang.String"} },
      { TEST_METHOD, "savWord#1.2", RES_OBJ+"newWord#1", "flush", null },
      { TEST_METHOD, "newUnit#1", "asgaard.lang.Unit", null, new Object[] {"Unit Z ShortName", "Unit Z LongName", new LinearScaling() }, new String[] {"java.lang.String", "java.lang.String", "asgaard.utils.unit.Convert"} },
      { TEST_METHOD, "savUnit#1", RES_OBJ+"newUnit#1", "flush", null },
      { TEST_METHOD, "newItem#1", "asgaard.lang.Item", null, new Object[] {"Item Z ShortName", "Item Z LongName", new LinearScaling() }, new String[] {"java.lang.String", "java.lang.String", "asgaard.utils.unit.Convert"} },
      { TEST_METHOD, "setItem#1", RES_OBJ+"newItem#1", "setItem", new Object[] { RES_OBJ+"getDefKey#1", "Item Y Name", "Item Y Title", "Item Y PRE", "Item Y POST", "Item Y Description" }, new String[] {"int" } },
      { TEST_METHOD, "savItem#1", RES_OBJ+"newItem#1", "flush", null },
      { TEST_METHOD, "newPerson#1", "asgaard.lang.Person", null, null },
      { TEST_METHOD, "modPerson#1.1", RES_OBJ+"newPerson#1", "setBirthdate", new Object[] {new java.util.Date(77, 11, 23)} },
      { TEST_METHOD, "modPerson#1.2", RES_OBJ+"newPerson#1", "setLastname", new Object[] {"Auer"} },
      { TEST_METHOD, "modPerson#1.3", RES_OBJ+"newPerson#1", "setFirstname", new Object[] {"Doris"} },
      { TEST_METHOD, "savPerson#1.1", RES_OBJ+"newPerson#1", "flush", null },
      { TEST_METHOD, "getPersonKey#1", RES_OBJ+"newPerson#1", "getKey", null },
      { TEST_METHOD, "modPerson#1.4", RES_OBJ+"newPerson#1", "setFirstname", new Object[] {"Birgit"} },
      { TEST_METHOD, "savPerson#1.2", RES_OBJ+"newPerson#1", "flush", null },
      { TEST_METHOD, "newPerson#2", "asgaard.lang.Person", null, null },
      { TEST_METHOD, "modPerson#2.1", RES_OBJ+"newPerson#2", "setBirthdate", new Object[] {new java.util.Date(68, 8, 2)} },
      { TEST_METHOD, "modPerson#2.2", RES_OBJ+"newPerson#2", "setLastname", new Object[] {"Weingartner"} },
      { TEST_METHOD, "modPerson#2.3", RES_OBJ+"newPerson#2", "setFirstname", new Object[] {"Franz"} },
      { TEST_METHOD, "savPerson#2", RES_OBJ+"newPerson#2", "flush", null },
      { TEST_METHOD, "getPersonKey#2", RES_OBJ+"newPerson#2", "getKey", null },
      { TEST_METHOD, "newLink#1", "asgaard.skid.BeanLink", null, new Object[] {RES_OBJ+"getPersonKey#2", RES_OBJ+"getPersonKey#1", RES_OBJ+"getDefKey#1", i0, i0, i0 }, new String[] { "int",  "int",  "int", "long", "long", "int"} },
      { TEST_METHOD, "newLink#2", "asgaard.skid.BeanLink", null, new Object[] {RES_OBJ+"getPersonKey#1", RES_OBJ+"getDefKey#1", RES_OBJ+"getPersonKey#2", i0, i0, i0 }, new String[] { "int",  "int",  "int", "long", "long", "int"} },
      { TEST_METHOD, "putLink#1", RES_OBJ+"newPerson#1", "putLink", new Object[] {RES_OBJ+"newLink#2"} },
      { TEST_METHOD, "putLink#2", RES_OBJ+"newDef#1", "putLink", new Object[] {RES_OBJ+"newLink#1"} },
      { TEST_METHOD, "getLink#1", RES_OBJ+"newPerson#1", "getLink", new Object[] { null }, new String[] {"asgaard.skid.BeanLinkFilter"} },
      { TEST_GET_ARRAY_ITEM, "firstLink#1", RES_OBJ+"getLink#1", i0 },
      { TEST_METHOD, "newLinkFilter#1", RES_OBJ+"firstLink#1", "getFilter", null },
      { TEST_METHOD, "suscrEvent#1", RES_OBJ+"newPerson#1", "suscribeEvent", new Object[] {RES_OBJ+"newPerson#2", RES_OBJ+"newPerson#1"}, new String[] {"asgaard.skid.RemoteBean", "asgaard.skid.RemoteBean"} },
      { TEST_METHOD, "addEvent#1", RES_OBJ+"newPerson#2", "addEvent", new Object[] {RES_OBJ+"newPerson#1"}, new String[] {"asgaard.skid.RemoteBean"} },
      { TEST_METHOD, "getEvent#1", RES_OBJ+"newPerson#1", "getEvent", new Object[] {i0}, new String[] {"long"}},
      { TEST_METHOD, "newFilter#1", RES_OBJ+"newPerson#1", "getFilter", null },
      { TEST_METHOD, "setFilter#1", RES_OBJ+"newFilter#1", "setFilterEntry", new Object[] {"Birthdate", new java.util.Date(77, 11, 23), new Byte(BeanBroker.FILTER_EQ)}, new String[] {"java.lang.String", "java.lang.Object", "byte"} },
      { TEST_METHOD, "getFilterKey#1", RES_OBJ+"newFilter#1", "getResultKeys", null },
      { TEST_GET_ARRAY_ITEM, "firstKey#1", RES_OBJ+"getFilterKey#1", i0 },
      { TEST_METHOD, "getBroker#1", RES_OBJ+"newPerson#1", "getBroker", null },
      { TEST_METHOD, "getFilterRes#1", RES_OBJ+"getBroker#1", "getBean", new Object[] {RES_OBJ+"firstKey#1"}, new String[] {"int"} },
      { TEST_METHOD, "newTest#1", "asgaard.skid.TestBean", null, null },
      { TEST_METHOD, "modTest#1", RES_OBJ+"newTest#1", "setName", new Object[] {"TEST"} },
      { TEST_METHOD, "savTest#1", RES_OBJ+"newTest#1", "flush", null },
      { TEST_METHOD, "getTestKey#1", RES_OBJ+"newTest#1", "getKey", null },
      { TEST_METHOD, "getDef#2", RES_OBJ+"getBroker#1", "getBean", new Object[] { new Integer(106) }, new String[] { "int" } },
      { TEST_METHOD, "getDefKey#2", RES_OBJ+"getDef#2", "getKey", null },
      { TEST_METHOD, "getTest#1", RES_OBJ+"getBroker#1", "getBean", new Object[] { RES_OBJ+"getTestKey#1" }, new String[] { "int" } },
    };

    public final static Object[][] TESTSCRIPT_BEANBROKER_FINAL = {
      { TEST_COMPARE_EQUAL, "compare L2/L2", RES_OBJ+"newLink#2", RES_OBJ+"firstLink#1" },
      { TEST_COMPARE_EQUAL, "compare P1/P1", RES_OBJ+"newPerson#1", RES_OBJ+"getFilterRes#1" },
      { TEST_METHOD, "encrPwd#1", RES_OBJ+"getBroker#1", "encryptPwd", new Object[] {"tiger"} },
    };

    public final static Object[][] TESTSCRIPT_BEANBROKER_REMOTE = {
      { TEST_METHOD, "newUserSession#1", RES_OBJ+"getBroker#1", "getUser", new Object[] {"klaus", BeanBroker.encryptPwd("sgdh")} },
      { TEST_METHOD, "newUserSession#2", "asgaard.skid.UserSession", null, new Object[] {"klaus", "sgdh", "128.130.167.57"} },
      { TEST_METHOD, "newUserSession#3", RES_OBJ+"getBroker#1", "getUser", new Object[] {"klaus", "klaus", BeanBroker.encryptPwd("sgdh")}, new String[] {"java.lang.Object"} },
      { TEST_METHOD, "savUserSession#2", RES_OBJ+"newUserSession#2", "save", null },
      { TEST_COMPARE_EQUAL, "checkSave", RES_OBJ+"savUserSession#2", new Boolean(true) },
      { TEST_COMPARE_EQUAL, "compare U1/U3", RES_OBJ+"savUserSession#1", RES_OBJ+"savUserSession#3" },
    };
//        UserSession u = new UserSession("klaus", "sgdh", host);
//        setUserParams(u, getUserParams());


/*
Skid.log.put( this.getClass().getName(), "test_button",
              LogMsg.LOG_WARNING, true,
              "Testing uuencode",
              new Float("3.4"));
LogMsg m = Skid.log.get(3, true)[0];
Float f = (Float) m.getLogBean();
output.append ( "HURRA ! >" + f.toString() + "<" );
/*
LogMsg m = Skid.log.get(57, true)[0];
String f = (String) m.getLogBean();
output.append ( "HURRA ! >" + f + "<" );
*/

	protected RemoteBroker skid;

  /**
   * Main-Methode
   */
  public static void main(String[] args) {
    System.out.println("Hello, this is skid.Test, checking the asgaard.skid package.");
    System.out.println("Usage: java asgaard.skid.TestSkid <host>");
    if (args.length < 1) {
      System.out.println("parameter missing: e.g. 128.130.167.57");
      System.exit( 0 );
    }
    TestSkid app = new TestSkid();
    try {
			BeanBroker.THIS = (RemoteBroker) Naming.lookup("//"+args[0] +"/"+ Skid.ServerName);
      BeanBroker.HOST = args[0];
      System.out.println("Connect to //" + args[0] +"/"+ Skid.ServerName);
    } catch (Exception e) {
      System.out.println("Could not connect to //" + args[0] +"/"+ Skid.ServerName);
      System.out.println(e.toString());
      e.printStackTrace();
      System.exit( 0 );
    }
    app.testIt(app);
  }

  /**
   * Returns a collection of all Testscripts
   */
  public Object[][] getTestScript() {
    return concatScripts(new Object[] { TestSkid.TESTSCRIPT_BEANBROKER_INTERFACE, TestSkid.TESTSCRIPT_BEANBROKER_REMOTE });
  }

  /**
   * Does the remote - TEST
   */
  public boolean testIt(Object local_handle) {
    try {
      BeanBroker.THIS.testMode(true);
      boolean ret = testIt(this.getClass().getName(), getTestScript(), local_handle);
      BeanBroker.THIS.testMode(false);
      return ret;
    } catch (Exception e) {
      return false;
    }
  }

}

