/**
 * SQL Resources
 * This file is part of Skid
 * (P) 1999 by Klaus Hammermller, klaus@ifs.tuwien.ac.at
 * http://www.ifs.tuwien.ac.at/~hammer
 *
 *@author KH
 *@created 060499 KH
 */

package asgaard.skid.resources;

import java.util.*;
import asgaard.skid.BeanBroker;

public class SQLRes extends java.util.ListResourceBundle {

	public Object[][] getContents() {
		return contents;
	}

	static Object[][] contents = {
    // DEFAULTS & DEFINES
	  // ==================
    { "dateFormat",     "" },
    // Datatypes
    { "DATE",           "LONG" },
    { "TIME",           "LONG" },
    { "TIMESTAMP",      "LONG" },
    { "TINYINT",        "INTEGER" },
    { "SMALLINT",       "INTEGER" },
    { "INTEGER",        "LONG" },
    { "BIGINT",         "LONG" },
    { "NUMERIC",        "DECIMAL" },
    { "DECIMAL",        "DECIMAL" },
    { "FLOAT",          "DECIMAL" },
    { "REAL",           "DECIMAL" },
    { "DOUBLE",         "DECIMAL" },
    { "CHAR",           "CHAR" },
    { "VARCHAR",        "VARCHAR" },
    { "LONGVARCHAR",    "LONGVARCHAR" },
    { "LONGVARBINARY",  "LONGVARBINARY" },
    { "VARBINARY",      "VARBINARY" },
    { "BINARY",         "BINARY" },
    { "BIT",            "INTEGER" },

	  // SCHLSSEL  (nur verschlsselte Schlssel, sonst nix)
	  // =========
		{ "dropCKEY",            " DROP TABLE cKey " },
    { "createCKEY",          " CREATE TABLE cKey ( " +
                                " nr INTEGER NOT NULL, " +
                                " k INTEGER NOT NULL ) " },
		{ "insertCKEY",          " INSERT INTO cKey VALUES ( 1, -1775304483 ) " },
	  // USER
	  // ====
		{ "dropUSER",          " DROP TABLE user " },
    { "createUSER",        " CREATE TABLE user (" +
	      					              " name VARCHAR NOT NULL, " +                      // 0 User-Name
	      					              " encr VARCHAR NOT NULL, " +                      // 1 encrypted password
                                " status VARCHAR, " +                             // 2 status 0 normal
                                " p INTEGER, " +                                  // 3 person#
                                " language VARCHAR, " +                           // 4 language
                                " eMail VARCHAR, " +                              // 5 email
                                " url VARCHAR, " +                                // 6 url
						                    " tsRegistered DECIMAL(19, 0), " +                // 7 timestamp
						                    " tsExpires DECIMAL(19, 0), " +                   // 8 timestamp
						                    " tsEnded DECIMAL(19, 0)) " },                    // 9 timestamp
		{ "insertUSER",        " INSERT INTO user VALUES ( 'klaus', '6A554E77F5CB9D3B', 'DA7h',  92214, 'GER', 'klaus@ifs.tuwien.ac.at', 'www.ifs.tuwien.ac.at/~hammer', 0, 0, 0 ) " },
    { "InsertUser", "INSERT INTO user VALUES ('{0}','{1}','{2}',{3},'{4}','{5}','{6}',{7},{8},{9})" }, // remark: last char != }
    { "SelectAllUser", "SELECT * FROM user " },
    // Bean ERZEUGEN
	  // =============
    { "dropBean",             " DROP TABLE Bean " },
    { "createBean",           " CREATE TABLE Bean ( " +
						                    " p INTEGER NOT NULL, " +                         // 0 Primary Key
						                    " pClass INTEGER, " +                             // 1 Class Key
						                    " tsCreated DECIMAL(19, 0) NOT NULL, " +          // 2 timestamp
						                    " tsModified DECIMAL(19, 0) NOT NULL, " +         // 3 timestamp
	      					              " identifier VARCHAR NOT NULL, " +                // 4 Long Name (automatically generated)
	      					              " name VARCHAR NOT NULL, " +                      // 5 Short Name
						                    " beantype INTEGER, " +                           // 6 Class Key
      						              " skidbean VARCHAR )" },                          // 7 The Bean
		{ "insertBean",          // class
                             " INSERT INTO Bean VALUES ( 1, "+String.valueOf(BeanBroker.TYPE_CLASS)+", 0, 0, 'asgaard.lang.Def','asgaard.lang.Def', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 2, "+String.valueOf(BeanBroker.TYPE_CLASS)+", 0, 0, 'asgaard.lang.Def','asgaard.lang.Word', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 3, "+String.valueOf(BeanBroker.TYPE_CLASS)+", 0, 0, 'asgaard.lang.Def','asgaard.lang.Unit', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             // system
                             " INSERT INTO Bean VALUES ( 100, 1, 0, 0, 'def:<none>','<none>', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 101, 1, 0, 0, 'def:Clone', 'Clone', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 102, 1, 0, 0, 'def:Author', 'Autor', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 103, 1, 0, 0, 'def:Owner', 'Owner', "+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             // --
                             // sex
                             " INSERT INTO Bean VALUES ( 140, 1, 0, 0, 'def:Sex','Sex',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 141, 1, 0, 0, 'def:M','M',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'male' ) \n" +
                             " INSERT INTO Bean VALUES ( 142, 1, 0, 0, 'def:F','F',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'female' ) \n" +
                             // language
                             " INSERT INTO Bean VALUES ( 150, 1, 0, 0, 'def:Language','Language',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 151, 1, 0, 0, 'def:German','German',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 152, 1, 0, 0, 'def:English','English',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             // nation
                             " INSERT INTO Bean VALUES ( 200, 1, 0, 0, 'def:Nation','Nation',"+String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", '' ) \n" +
                             " INSERT INTO Bean VALUES ( 201, 1, 0, 0, 'def:AF','AF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Afghanistan' ) \n" +
                             " INSERT INTO Bean VALUES ( 202, 1, 0, 0, 'def:AL','AL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Albania' ) \n" +
                             " INSERT INTO Bean VALUES ( 203, 1, 0, 0, 'def:DZ','DZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Algeria' ) \n" +
                             " INSERT INTO Bean VALUES ( 204, 1, 0, 0, 'def:AS','AS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'American Samoa' ) \n" +
                             " INSERT INTO Bean VALUES ( 205, 1, 0, 0, 'def:AD','AD'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Andorra' ) \n" +
                             " INSERT INTO Bean VALUES ( 206, 1, 0, 0, 'def:AO','AO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Angola' ) \n" +
                             " INSERT INTO Bean VALUES ( 207, 1, 0, 0, 'def:AI','AI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Anguilla' ) \n" +
                             " INSERT INTO Bean VALUES ( 208, 1, 0, 0, 'def:AQ','AQ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Antarctica' ) \n" +
                             " INSERT INTO Bean VALUES ( 209, 1, 0, 0, 'def:AG','AG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Antigua And Barbuda' ) \n" +
                             " INSERT INTO Bean VALUES ( 210, 1, 0, 0, 'def:AR','AR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Argentina' ) \n" +
                             " INSERT INTO Bean VALUES ( 211, 1, 0, 0, 'def:AM','AM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Armenia' ) \n" +
                             " INSERT INTO Bean VALUES ( 212, 1, 0, 0, 'def:AW','AW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Aruba' ) \n" +
                             " INSERT INTO Bean VALUES ( 213, 1, 0, 0, 'def:AU','AU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Australia' ) \n" +
                             " INSERT INTO Bean VALUES ( 214, 1, 0, 0, 'def:AT','AT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Austria' ) \n" +
                             " INSERT INTO Bean VALUES ( 215, 1, 0, 0, 'def:AZ','AZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Azerbaijan' ) \n" +
                             " INSERT INTO Bean VALUES ( 216, 1, 0, 0, 'def:BS','BS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bahamas' ) \n" +
                             " INSERT INTO Bean VALUES ( 217, 1, 0, 0, 'def:BH','BH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bahrain' ) \n" +
                             " INSERT INTO Bean VALUES ( 218, 1, 0, 0, 'def:BD','BD'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bangladesh' ) \n" +
                             " INSERT INTO Bean VALUES ( 219, 1, 0, 0, 'def:BB','BB'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Barbados' ) \n" +
                             " INSERT INTO Bean VALUES ( 220, 1, 0, 0, 'def:BY','BY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Belarus' ) \n" +
                             " INSERT INTO Bean VALUES ( 221, 1, 0, 0, 'def:BE','BE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Belgium' ) \n" +
                             " INSERT INTO Bean VALUES ( 222, 1, 0, 0, 'def:BZ','BZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Belize' ) \n" +
                             " INSERT INTO Bean VALUES ( 223, 1, 0, 0, 'def:BJ','BJ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Benin' ) \n" +
                             " INSERT INTO Bean VALUES ( 224, 1, 0, 0, 'def:BM','BM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bermuda' ) \n" +
                             " INSERT INTO Bean VALUES ( 225, 1, 0, 0, 'def:BT','BT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bhutan' ) \n" +
                             " INSERT INTO Bean VALUES ( 226, 1, 0, 0, 'def:BO','BO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bolivia' ) \n" +
                             " INSERT INTO Bean VALUES ( 227, 1, 0, 0, 'def:BA','BA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bosnia And Herzegowina' ) \n" +
                             " INSERT INTO Bean VALUES ( 228, 1, 0, 0, 'def:BW','BW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Botswana' ) \n" +
                             " INSERT INTO Bean VALUES ( 229, 1, 0, 0, 'def:BV','BV'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bouvet Island' ) \n" +
                             " INSERT INTO Bean VALUES ( 230, 1, 0, 0, 'def:BR','BR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Brazil' ) \n" +
                             " INSERT INTO Bean VALUES ( 231, 1, 0, 0, 'def:IO','IO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'British Indian Ocean Territory' ) \n" +
                             " INSERT INTO Bean VALUES ( 232, 1, 0, 0, 'def:BN','BN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Brunei Darussalam' ) \n" +
                             " INSERT INTO Bean VALUES ( 233, 1, 0, 0, 'def:BG','BG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Bulgaria' ) \n" +
                             " INSERT INTO Bean VALUES ( 234, 1, 0, 0, 'def:BF','BF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Burkina Faso' ) \n" +
                             " INSERT INTO Bean VALUES ( 235, 1, 0, 0, 'def:BI','BI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Burundi' ) \n" +
                             " INSERT INTO Bean VALUES ( 236, 1, 0, 0, 'def:KH','KH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cambodia' ) \n" +
                             " INSERT INTO Bean VALUES ( 237, 1, 0, 0, 'def:CM','CM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cameroon' ) \n" +
                             " INSERT INTO Bean VALUES ( 238, 1, 0, 0, 'def:CA','CA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Canada' ) \n" +
                             " INSERT INTO Bean VALUES ( 239, 1, 0, 0, 'def:CV','CV'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cape Verde' ) \n" +
                             " INSERT INTO Bean VALUES ( 240, 1, 0, 0, 'def:KY','KY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cayman Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 241, 1, 0, 0, 'def:CF','CF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Central African Republic' ) \n" +
                             " INSERT INTO Bean VALUES ( 242, 1, 0, 0, 'def:TD','TD'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Chad' ) \n" +
                             " INSERT INTO Bean VALUES ( 243, 1, 0, 0, 'def:CL','CL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Chile' ) \n" +
                             " INSERT INTO Bean VALUES ( 244, 1, 0, 0, 'def:CN','CN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'China' ) \n" +
                             " INSERT INTO Bean VALUES ( 245, 1, 0, 0, 'def:CX','CX'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Christmas Island' ) \n" +
                             " INSERT INTO Bean VALUES ( 246, 1, 0, 0, 'def:CC','CC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cocos (Keeling) Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 247, 1, 0, 0, 'def:CO','CO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Colombia' ) \n" +
                             " INSERT INTO Bean VALUES ( 248, 1, 0, 0, 'def:KM','KM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Comoros' ) \n" +
                             " INSERT INTO Bean VALUES ( 249, 1, 0, 0, 'def:CG','CG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Congo' ) \n" +
                             " INSERT INTO Bean VALUES ( 250, 1, 0, 0, 'def:CK','CK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cook Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 251, 1, 0, 0, 'def:CR','CR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Costa Rica' ) \n" +
                             " INSERT INTO Bean VALUES ( 252, 1, 0, 0, 'def:CI','CI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cote D-Ivoire' ) \n" +
                             " INSERT INTO Bean VALUES ( 253, 1, 0, 0, 'def:HR','HR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Croatia' ) \n" +
                             " INSERT INTO Bean VALUES ( 254, 1, 0, 0, 'def:CU','CU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cuba' ) \n" +
                             " INSERT INTO Bean VALUES ( 255, 1, 0, 0, 'def:CY','CY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Cyprus' ) \n" +
                             " INSERT INTO Bean VALUES ( 256, 1, 0, 0, 'def:CZ','CZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Czech Republic' ) \n" +
                             " INSERT INTO Bean VALUES ( 257, 1, 0, 0, 'def:DK','DK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Denmark' ) \n" +
                             " INSERT INTO Bean VALUES ( 259, 1, 0, 0, 'def:DJ','DJ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Djibouti' ) \n" +
                             " INSERT INTO Bean VALUES ( 260, 1, 0, 0, 'def:DM','DM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Dominica' ) \n" +
                             " INSERT INTO Bean VALUES ( 261, 1, 0, 0, 'def:DO','DO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Dominican Republic' ) \n" +
                             " INSERT INTO Bean VALUES ( 262, 1, 0, 0, 'def:TP','TP'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'East Timor' ) \n" +
                             " INSERT INTO Bean VALUES ( 263, 1, 0, 0, 'def:EC','EC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Ecuador' ) \n" +
                             " INSERT INTO Bean VALUES ( 264, 1, 0, 0, 'def:EG','EG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Egypt' ) \n" +
                             " INSERT INTO Bean VALUES ( 265, 1, 0, 0, 'def:SV','SV'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'El Salvador' ) \n" +
                             " INSERT INTO Bean VALUES ( 266, 1, 0, 0, 'def:GQ','GQ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Equatorial Guinea' ) \n" +
                             " INSERT INTO Bean VALUES ( 267, 1, 0, 0, 'def:ER','ER'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Eritrea' ) \n" +
                             " INSERT INTO Bean VALUES ( 269, 1, 0, 0, 'def:EE','EE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Estonia' ) \n" +
                             " INSERT INTO Bean VALUES ( 270, 1, 0, 0, 'def:ET','ET'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Ethiopia' ) \n" +
                             " INSERT INTO Bean VALUES ( 271, 1, 0, 0, 'def:FK','FK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Falkland Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 272, 1, 0, 0, 'def:FO','FO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Faroe Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 273, 1, 0, 0, 'def:FJ','FJ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Fiji' ) \n" +
                             " INSERT INTO Bean VALUES ( 274, 1, 0, 0, 'def:FI','FI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Finland' ) \n" +
                             " INSERT INTO Bean VALUES ( 275, 1, 0, 0, 'def:FR','FR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'France' ) \n" +
                             " INSERT INTO Bean VALUES ( 276, 1, 0, 0, 'def:FX','FX'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'France, Metropolitan' ) \n" +
                             " INSERT INTO Bean VALUES ( 277, 1, 0, 0, 'def:GF','GF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'French Guiana' ) \n" +
                             " INSERT INTO Bean VALUES ( 278, 1, 0, 0, 'def:PF','PF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'French Polynesia' ) \n" +
                             " INSERT INTO Bean VALUES ( 279, 1, 0, 0, 'def:TF','TF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'French Southern Territories' ) \n" +
                             " INSERT INTO Bean VALUES ( 280, 1, 0, 0, 'def:GA','GA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Gabon' ) \n" +
                             " INSERT INTO Bean VALUES ( 281, 1, 0, 0, 'def:GM','GM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Gambia' ) \n" +
                             " INSERT INTO Bean VALUES ( 282, 1, 0, 0, 'def:GE','GE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Georgia' ) \n" +
                             " INSERT INTO Bean VALUES ( 258, 1, 0, 0, 'def:DE','DE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Germany' ) \n" +
                             " INSERT INTO Bean VALUES ( 284, 1, 0, 0, 'def:GH','GH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Ghana' ) \n" +
                             " INSERT INTO Bean VALUES ( 285, 1, 0, 0, 'def:GI','GI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Gibraltar' ) \n" +
                             " INSERT INTO Bean VALUES ( 286, 1, 0, 0, 'def:GR','GR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Greece' ) \n" +
                             " INSERT INTO Bean VALUES ( 287, 1, 0, 0, 'def:GL','GL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Greenland' ) \n" +
                             " INSERT INTO Bean VALUES ( 288, 1, 0, 0, 'def:GD','GD'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Grenada' ) \n" +
                             " INSERT INTO Bean VALUES ( 289, 1, 0, 0, 'def:GP','GP'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Guadeloupe' ) \n" +
                             " INSERT INTO Bean VALUES ( 290, 1, 0, 0, 'def:GU','GU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Guam' ) \n" +
                             " INSERT INTO Bean VALUES ( 291, 1, 0, 0, 'def:GT','GT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Guatemala' ) \n" +
                             " INSERT INTO Bean VALUES ( 292, 1, 0, 0, 'def:GN','GN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Guinea' ) \n" +
                             " INSERT INTO Bean VALUES ( 293, 1, 0, 0, 'def:GW','GW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Guinea-Bissau' ) \n" +
                             " INSERT INTO Bean VALUES ( 294, 1, 0, 0, 'def:GY','GY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Guyana' ) \n" +
                             " INSERT INTO Bean VALUES ( 295, 1, 0, 0, 'def:HT','HT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Haiti' ) \n" +
                             " INSERT INTO Bean VALUES ( 296, 1, 0, 0, 'def:HM','HM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Heard And Mc Donald Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 297, 1, 0, 0, 'def:HN','HN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Honduras' ) \n" +
                             " INSERT INTO Bean VALUES ( 298, 1, 0, 0, 'def:HK','HK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Hong Kong' ) \n" +
                             " INSERT INTO Bean VALUES ( 299, 1, 0, 0, 'def:HU','HU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Hungary' ) \n" +
                             " INSERT INTO Bean VALUES ( 300, 1, 0, 0, 'def:IS','IS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Iceland' ) \n" +
                             " INSERT INTO Bean VALUES ( 301, 1, 0, 0, 'def:IN','IN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'India' ) \n" +
                             " INSERT INTO Bean VALUES ( 302, 1, 0, 0, 'def:ID','ID'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Indonesia' ) \n" +
                             " INSERT INTO Bean VALUES ( 303, 1, 0, 0, 'def:IR','IR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Iran' ) \n" +
                             " INSERT INTO Bean VALUES ( 304, 1, 0, 0, 'def:IQ','IQ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Iraq' ) \n" +
                             " INSERT INTO Bean VALUES ( 305, 1, 0, 0, 'def:IE','IE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Ireland' ) \n" +
                             " INSERT INTO Bean VALUES ( 306, 1, 0, 0, 'def:IL','IL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Israel' ) \n" +
                             " INSERT INTO Bean VALUES ( 307, 1, 0, 0, 'def:IT','IT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Italy' ) \n" +
                             " INSERT INTO Bean VALUES ( 308, 1, 0, 0, 'def:JM','JM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Jamaica' ) \n" +
                             " INSERT INTO Bean VALUES ( 309, 1, 0, 0, 'def:JP','JP'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Japan' ) \n" +
                             " INSERT INTO Bean VALUES ( 310, 1, 0, 0, 'def:JO','JO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Jordan' ) \n" +
                             " INSERT INTO Bean VALUES ( 311, 1, 0, 0, 'def:KZ','KZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Kazakhstan' ) \n" +
                             " INSERT INTO Bean VALUES ( 312, 1, 0, 0, 'def:KE','KE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Kenya' ) \n" +
                             " INSERT INTO Bean VALUES ( 313, 1, 0, 0, 'def:KI','KI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Kiribati' ) \n" +
                             " INSERT INTO Bean VALUES ( 314, 1, 0, 0, 'def:KP','KP'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'North Korea (Peoples Republic Of Korea)' ) \n" +
                             " INSERT INTO Bean VALUES ( 315, 1, 0, 0, 'def:KR','KR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'South Korea (Republic Of Korea)' ) \n" +
                             " INSERT INTO Bean VALUES ( 316, 1, 0, 0, 'def:KW','KW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Kuwait' ) \n" +
                             " INSERT INTO Bean VALUES ( 317, 1, 0, 0, 'def:KG','KG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Kyrgyzstan' ) \n" +
                             " INSERT INTO Bean VALUES ( 318, 1, 0, 0, 'def:LA','LA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Lao Peoples Republic' ) \n" +
                             " INSERT INTO Bean VALUES ( 319, 1, 0, 0, 'def:LV','LV'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Latvia' ) \n" +
                             " INSERT INTO Bean VALUES ( 320, 1, 0, 0, 'def:LB','LB'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Lebanon' ) \n" +
                             " INSERT INTO Bean VALUES ( 321, 1, 0, 0, 'def:LS','LS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Lesotho' ) \n" +
                             " INSERT INTO Bean VALUES ( 322, 1, 0, 0, 'def:LR','LR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Liberia' ) \n" +
                             " INSERT INTO Bean VALUES ( 323, 1, 0, 0, 'def:LY','LY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Libyan Arab Jamahiriya' ) \n" +
                             " INSERT INTO Bean VALUES ( 324, 1, 0, 0, 'def:LI','LI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Liechtenstein' ) \n" +
                             " INSERT INTO Bean VALUES ( 325, 1, 0, 0, 'def:LT','LT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Lithuania' ) \n" +
                             " INSERT INTO Bean VALUES ( 326, 1, 0, 0, 'def:LU','LU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Luxembourg' ) \n" +
                             " INSERT INTO Bean VALUES ( 327, 1, 0, 0, 'def:MO','MO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Macau' ) \n" +
                             " INSERT INTO Bean VALUES ( 328, 1, 0, 0, 'def:MK','MK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Macedonia' ) \n" +
                             " INSERT INTO Bean VALUES ( 329, 1, 0, 0, 'def:MG','MG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Madagascar' ) \n" +
                             " INSERT INTO Bean VALUES ( 330, 1, 0, 0, 'def:MW','MW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Malawi' ) \n" +
                             " INSERT INTO Bean VALUES ( 331, 1, 0, 0, 'def:MY','MY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Malaysia' ) \n" +
                             " INSERT INTO Bean VALUES ( 332, 1, 0, 0, 'def:MV','MV'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Maldives' ) \n" +
                             " INSERT INTO Bean VALUES ( 333, 1, 0, 0, 'def:ML','ML'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mali' ) \n" +
                             " INSERT INTO Bean VALUES ( 334, 1, 0, 0, 'def:MT','MT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Malta' ) \n" +
                             " INSERT INTO Bean VALUES ( 335, 1, 0, 0, 'def:MH','MH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Marshall Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 336, 1, 0, 0, 'def:MQ','MQ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Martinique' ) \n" +
                             " INSERT INTO Bean VALUES ( 337, 1, 0, 0, 'def:MR','MR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mauritania' ) \n" +
                             " INSERT INTO Bean VALUES ( 338, 1, 0, 0, 'def:MU','MU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mauritius' ) \n" +
                             " INSERT INTO Bean VALUES ( 339, 1, 0, 0, 'def:YT','YT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mayotte' ) \n" +
                             " INSERT INTO Bean VALUES ( 340, 1, 0, 0, 'def:MX','MX'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mexico' ) \n" +
                             " INSERT INTO Bean VALUES ( 341, 1, 0, 0, 'def:FM','FM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Micronesia' ) \n" +
                             " INSERT INTO Bean VALUES ( 342, 1, 0, 0, 'def:MD','MD'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Moldova' ) \n" +
                             " INSERT INTO Bean VALUES ( 343, 1, 0, 0, 'def:MC','MC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Monaco' ) \n" +
                             " INSERT INTO Bean VALUES ( 344, 1, 0, 0, 'def:MN','MN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mongolia' ) \n" +
                             " INSERT INTO Bean VALUES ( 345, 1, 0, 0, 'def:MS','MS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Montserrat' ) \n" +
                             " INSERT INTO Bean VALUES ( 346, 1, 0, 0, 'def:MA','MA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Morocco' ) \n" +
                             " INSERT INTO Bean VALUES ( 347, 1, 0, 0, 'def:MZ','MZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Mozambique' ) \n" +
                             " INSERT INTO Bean VALUES ( 348, 1, 0, 0, 'def:MM','MM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Myanmar' ) \n" +
                             " INSERT INTO Bean VALUES ( 349, 1, 0, 0, 'def:NA','NA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Namibia' ) \n" +
                             " INSERT INTO Bean VALUES ( 350, 1, 0, 0, 'def:NR','NR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Nauru' ) \n" +
                             " INSERT INTO Bean VALUES ( 351, 1, 0, 0, 'def:NP','NP'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Nepal' ) \n" +
                             " INSERT INTO Bean VALUES ( 352, 1, 0, 0, 'def:NL','NL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Netherlands' ) \n" +
                             " INSERT INTO Bean VALUES ( 353, 1, 0, 0, 'def:AN','AN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Netherlands Antilles' ) \n" +
                             " INSERT INTO Bean VALUES ( 354, 1, 0, 0, 'def:NC','NC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'New Caledonia' ) \n" +
                             " INSERT INTO Bean VALUES ( 355, 1, 0, 0, 'def:NZ','NZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'New Zealand' ) \n" +
                             " INSERT INTO Bean VALUES ( 356, 1, 0, 0, 'def:NI','NI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Nicaragua' ) \n" +
                             " INSERT INTO Bean VALUES ( 357, 1, 0, 0, 'def:NE','NE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Niger' ) \n" +
                             " INSERT INTO Bean VALUES ( 358, 1, 0, 0, 'def:NG','NG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Nigeria' ) \n" +
                             " INSERT INTO Bean VALUES ( 359, 1, 0, 0, 'def:NU','NU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Niue' ) \n" +
                             " INSERT INTO Bean VALUES ( 360, 1, 0, 0, 'def:NF','NF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Norfolk Island' ) \n" +
                             " INSERT INTO Bean VALUES ( 361, 1, 0, 0, 'def:MP','MP'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Northern Mariana Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 362, 1, 0, 0, 'def:NO','NO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Norway' ) \n" +
                             " INSERT INTO Bean VALUES ( 364, 1, 0, 0, 'def:OM','OM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Oman' ) \n" +
                             " INSERT INTO Bean VALUES ( 365, 1, 0, 0, 'def:PK','PK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Pakistan' ) \n" +
                             " INSERT INTO Bean VALUES ( 366, 1, 0, 0, 'def:PW','PW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Palau' ) \n" +
                             " INSERT INTO Bean VALUES ( 367, 1, 0, 0, 'def:PA','PA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Panama' ) \n" +
                             " INSERT INTO Bean VALUES ( 368, 1, 0, 0, 'def:PG','PG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Papua New Guinea' ) \n" +
                             " INSERT INTO Bean VALUES ( 369, 1, 0, 0, 'def:PY','PY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Paraguay' ) \n" +
                             " INSERT INTO Bean VALUES ( 370, 1, 0, 0, 'def:PE','PE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Peru' ) \n" +
                             " INSERT INTO Bean VALUES ( 371, 1, 0, 0, 'def:PH','PH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Philippines' ) \n" +
                             " INSERT INTO Bean VALUES ( 372, 1, 0, 0, 'def:PN','PN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Pitcairn' ) \n" +
                             " INSERT INTO Bean VALUES ( 373, 1, 0, 0, 'def:PL','PL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Poland' ) \n" +
                             " INSERT INTO Bean VALUES ( 374, 1, 0, 0, 'def:PT','PT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Portugal' ) \n" +
                             " INSERT INTO Bean VALUES ( 375, 1, 0, 0, 'def:PR','PR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Puerto Rico' ) \n" +
                             " INSERT INTO Bean VALUES ( 376, 1, 0, 0, 'def:QA','QA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Qatar' ) \n" +
                             " INSERT INTO Bean VALUES ( 377, 1, 0, 0, 'def:RE','RE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Reunion' ) \n" +
                             " INSERT INTO Bean VALUES ( 378, 1, 0, 0, 'def:RO','RO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Romania' ) \n" +
                             " INSERT INTO Bean VALUES ( 379, 1, 0, 0, 'def:RU','RU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Russian Federation' ) \n" +
                             " INSERT INTO Bean VALUES ( 380, 1, 0, 0, 'def:RW','RW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Rwanda' ) \n" +
                             " INSERT INTO Bean VALUES ( 381, 1, 0, 0, 'def:KN','KN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Saint Kitts And Nevis' ) \n" +
                             " INSERT INTO Bean VALUES ( 382, 1, 0, 0, 'def:LC','LC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Saint Lucia' ) \n" +
                             " INSERT INTO Bean VALUES ( 383, 1, 0, 0, 'def:VC','VC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Saint Vincent And The Grenadines' ) \n" +
                             " INSERT INTO Bean VALUES ( 384, 1, 0, 0, 'def:WS','WS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Samoa' ) \n" +
                             " INSERT INTO Bean VALUES ( 385, 1, 0, 0, 'def:SM','SM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'San Marino' ) \n" +
                             " INSERT INTO Bean VALUES ( 386, 1, 0, 0, 'def:ST','ST'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Sao Tome And Principe' ) \n" +
                             " INSERT INTO Bean VALUES ( 387, 1, 0, 0, 'def:SA','SA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Saudi Arabia' ) \n" +
                             " INSERT INTO Bean VALUES ( 389, 1, 0, 0, 'def:SN','SN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Senegal' ) \n" +
                             " INSERT INTO Bean VALUES ( 390, 1, 0, 0, 'def:SC','SC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Seychelles' ) \n" +
                             " INSERT INTO Bean VALUES ( 391, 1, 0, 0, 'def:SL','SL'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Sierra Leone' ) \n" +
                             " INSERT INTO Bean VALUES ( 392, 1, 0, 0, 'def:SG','SG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Singapore' ) \n" +
                             " INSERT INTO Bean VALUES ( 393, 1, 0, 0, 'def:SK','SK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Slovakia' ) \n" +
                             " INSERT INTO Bean VALUES ( 394, 1, 0, 0, 'def:SI','SI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Slovenia' ) \n" +
                             " INSERT INTO Bean VALUES ( 395, 1, 0, 0, 'def:SB','SB'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Solomon Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 396, 1, 0, 0, 'def:SO','SO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Somalia' ) \n" +
                             " INSERT INTO Bean VALUES ( 397, 1, 0, 0, 'def:ZA','ZA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'South Africa' ) \n" +
                             " INSERT INTO Bean VALUES ( 398, 1, 0, 0, 'def:GS','GS'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'South Georgia And The South Sandwich Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 268, 1, 0, 0, 'def:ES','ES'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Spain' ) \n" +
                             " INSERT INTO Bean VALUES ( 400, 1, 0, 0, 'def:LK','LK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Sri Lanka' ) \n" +
                             " INSERT INTO Bean VALUES ( 401, 1, 0, 0, 'def:SH','SH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'St Helena' ) \n" +
                             " INSERT INTO Bean VALUES ( 402, 1, 0, 0, 'def:PM','PM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'St Pierre and Miquelon' ) \n" +
                             " INSERT INTO Bean VALUES ( 403, 1, 0, 0, 'def:SD','SD'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Sudan' ) \n" +
                             " INSERT INTO Bean VALUES ( 404, 1, 0, 0, 'def:SR','SR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Suriname' ) \n" +
                             " INSERT INTO Bean VALUES ( 405, 1, 0, 0, 'def:SJ','SJ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Svalbard And Jan Mayen Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 406, 1, 0, 0, 'def:SZ','SZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Swaziland' ) \n" +
                             " INSERT INTO Bean VALUES ( 407, 1, 0, 0, 'def:SE','SE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Sweden' ) \n" +
                             " INSERT INTO Bean VALUES ( 388, 1, 0, 0, 'def:CH','CH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Switzerland' ) \n" +
                             " INSERT INTO Bean VALUES ( 409, 1, 0, 0, 'def:SY','SY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Syrian Arab Republic' ) \n" +
                             " INSERT INTO Bean VALUES ( 410, 1, 0, 0, 'def:TW','TW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Taiwan' ) \n" +
                             " INSERT INTO Bean VALUES ( 411, 1, 0, 0, 'def:TJ','TJ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Tajikistan' ) \n" +
                             " INSERT INTO Bean VALUES ( 412, 1, 0, 0, 'def:TZ','TZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Tanzania' ) \n" +
                             " INSERT INTO Bean VALUES ( 413, 1, 0, 0, 'def:TH','TH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Thailand' ) \n" +
                             " INSERT INTO Bean VALUES ( 414, 1, 0, 0, 'def:TG','TG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Togo' ) \n" +
                             " INSERT INTO Bean VALUES ( 415, 1, 0, 0, 'def:TK','TK'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Tokelau' ) \n" +
                             " INSERT INTO Bean VALUES ( 416, 1, 0, 0, 'def:TO','TO'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Tonga' ) \n" +
                             " INSERT INTO Bean VALUES ( 417, 1, 0, 0, 'def:TT','TT'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Trinidad And Tobago' ) \n" +
                             " INSERT INTO Bean VALUES ( 418, 1, 0, 0, 'def:TN','TN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Tunisia' ) \n" +
                             " INSERT INTO Bean VALUES ( 419, 1, 0, 0, 'def:TR','TR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Turkey' ) \n" +
                             " INSERT INTO Bean VALUES ( 420, 1, 0, 0, 'def:TM','TM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Turkmenistan' ) \n" +
                             " INSERT INTO Bean VALUES ( 421, 1, 0, 0, 'def:TC','TC'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Turks And Caicos Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 422, 1, 0, 0, 'def:TV','TV'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Tuvalu' ) \n" +
                             " INSERT INTO Bean VALUES ( 423, 1, 0, 0, 'def:UG','UG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Uganda' ) \n" +
                             " INSERT INTO Bean VALUES ( 424, 1, 0, 0, 'def:UA','UA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Ukraine' ) \n" +
                             " INSERT INTO Bean VALUES ( 425, 1, 0, 0, 'def:AE','AE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'United Arab Emirates' ) \n" +
                             " INSERT INTO Bean VALUES ( 426, 1, 0, 0, 'def:GB','GB'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'United Kingdom' ) \n" +
                             " INSERT INTO Bean VALUES ( 427, 1, 0, 0, 'def:UY','UY'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Uruguay' ) \n" +
                             " INSERT INTO Bean VALUES ( 428, 1, 0, 0, 'def:US','US'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'U.S.A.' ) \n" +
                             " INSERT INTO Bean VALUES ( 429, 1, 0, 0, 'def:UM','UM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'U.S. Minor Outlying Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 430, 1, 0, 0, 'def:UZ','UZ'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Uzbekistan' ) \n" +
                             " INSERT INTO Bean VALUES ( 431, 1, 0, 0, 'def:VU','VU'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Vanuatu' ) \n" +
                             " INSERT INTO Bean VALUES ( 432, 1, 0, 0, 'def:VA','VA'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Vatican City State' ) \n" +
                             " INSERT INTO Bean VALUES ( 433, 1, 0, 0, 'def:VE','VE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Venezuela' ) \n" +
                             " INSERT INTO Bean VALUES ( 434, 1, 0, 0, 'def:VN','VN'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Viet Nam' ) \n" +
                             " INSERT INTO Bean VALUES ( 435, 1, 0, 0, 'def:VG','VG'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Virgin Islands(British)' ) \n" +
                             " INSERT INTO Bean VALUES ( 436, 1, 0, 0, 'def:VI','VI'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Virgin Islands (US)' ) \n" +
                             " INSERT INTO Bean VALUES ( 437, 1, 0, 0, 'def:WF','WF'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Wallis And Futuna Islands' ) \n" +
                             " INSERT INTO Bean VALUES ( 438, 1, 0, 0, 'def:EH','EH'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Western Sahara' ) \n" +
                             " INSERT INTO Bean VALUES ( 439, 1, 0, 0, 'def:YE','YE'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Yemen' ) \n" +
                             " INSERT INTO Bean VALUES ( 440, 1, 0, 0, 'def:ZR','ZR'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Zaire' ) \n" +
                             " INSERT INTO Bean VALUES ( 431, 1, 0, 0, 'def:ZM','ZM'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Zambia' ) \n" +
                             " INSERT INTO Bean VALUES ( 442, 1, 0, 0, 'def:ZW','ZW'," + String.valueOf(BeanBroker.TYPE_LIGHTWEIGHT)+", 'Zimbabwe' ) \n" },

    { "selectRunningNr", "SELECT p FROM Bean WHERE (p >= {0}) and (p < {1}) " },
    { "deleteTestBeans", "DELETE FROM Bean WHERE (p >= "+String.valueOf(BeanBroker.PUBLIC_ID*BeanBroker.ID_HIGH)+") and (p < "+String.valueOf((1+BeanBroker.PUBLIC_ID)*BeanBroker.ID_HIGH)+ ") "},
    { "selectBeanClasses", "SELECT p, name, beantype FROM Bean WHERE (pClass = "+String.valueOf(BeanBroker.TYPE_CLASS)+") " },
    { "dropSelectClass",   "" },
    { "createSelectClass", "" },
    { "callSelectClass", "" },
    { "SelectClass", "SELECT p, name, beantype FROM Bean WHERE (pClass = "+String.valueOf(BeanBroker.TYPE_CLASS)+") and (name = '{0}') " },
    { "dropInsertClass",   "" },
    { "createInsertClass", "" },
    { "callInsertClass", "" },
    { "InsertClass", "INSERT INTO Bean VALUES ({0},1,0,0,'{1}','{1}',"+String.valueOf(BeanBroker.TYPE_CLASS)+",'{1}')" }, // remark: last char != }
    { "dropInsertBean",   "" },
    { "createInsertBean", "" },
    { "callInsertBean", "" },
    { "InsertBean", "INSERT INTO Bean VALUES ({0},{1},{2},{3},'{4}','{5}',{6},'{7}')" }, // remark: last char != }
    { "dropUpdateBean",   "" },
    { "createUpdateBean", "" },
    { "callUpdateBean", "" },
    { "UpdateBean", "UPDATE Bean  SET tsModified = {3}, identifier = '{4}', name = '{5}', skidbean = '{6}' WHERE (p = {0}) " }, // remark: last char != }
    { "dropSelectBean",   "" },
    { "createSelectBean", "" },
    { "callSelectBean", "" },
    { "SelectBean", "SELECT * FROM Bean WHERE (p = {0}) " }, // remark: last char != }
    { "SelectAllBeans", "SELECT * FROM Bean " },
    // Link erzeugen
    // =============
    { "dropLINK",         " DROP TABLE Link " },
    { "createLINK",        " CREATE TABLE Link ( " +
						                    " pFrom INTEGER, " +                              // 0 FROM
                                " nr INTEGER, " +                                 // 1 (not part of the key!)
						                    " pTo INTEGER NOT NULL, " +                       // 2 TO
						                    " pBy INTEGER, " +                                // 3 RELATE
						                    " tsCreated DECIMAL(19, 0) NOT NULL, " +          // 4 timestamp
						                    " tsModified DECIMAL(19, 0) NOT NULL, " +         // 5 timestamp
						                    " tsBegin DECIMAL(19, 0) NOT NULL, " +            // 6 timestamp
						                    " tsEnd DECIMAL(19, 0) NOT NULL, " +              // 7 timestamp
			      			              " state INTEGER )" },                             // 8 read/add/mod/exec for system/owner/creator/group/other
    { "deleteTestLinks", "DELETE FROM Link WHERE (pFrom >= "+String.valueOf(BeanBroker.PUBLIC_ID*BeanBroker.ID_HIGH)+") and (pFrom < "+String.valueOf((1+BeanBroker.PUBLIC_ID)*BeanBroker.ID_HIGH)+ ") "},
    { "dropInsertLink",   "" },
    { "createInsertLink", "" },
    { "callInsertLink", "" },
    { "InsertLink", "INSERT INTO Link VALUES ({0},{1},{2},{3},{4},{5},{6},{7},{8})" }, // remark: last char != }
    { "dropUpdateLink",   "" },
    { "createUpdateLink", "" },
    { "callUpdateLink", "" },
    { "UpdateLink", "UPDATE Link  SET nr = {1}, tsModified = {5}, tsBegin = {6}, tsEnd = {7}, state = {8} WHERE (pFrom = {0}) AND (pTo = {2}) AND (pBy = {3}) " }, // remark: last char != }
    { "dropSelectLink",   "" },
    { "createSelectLink", "" },
    { "callSelectLink", "" },
    { "SelectLink", "SELECT * FROM Link WHERE (pFrom = {0}) AND (pTo = {2}) AND (pBy = {3}) " }, // remark: last char != }
    { "dropSelectLink2",   "" },
    { "createSelectLink2", "" },
    { "callSelectLink2", "" },
    { "SelectLink2", "SELECT * FROM Link WHERE {0} ORDER BY pTo, nr " }, // remark: last char != }
    { "SelectAllLinks", "SELECT * FROM Link " },
    // KEY
    // ===
    { "dropCreateKey", ""},
    { "createCreateKey", ""},
    { "callCreateKey", ""},
    { "CreateKey", "CREATE TABLE {0} ({1})"},
    { "dropDeleteKey", ""},
    { "createDeleteKey", ""},
    { "callDeleteKey", ""},
    { "DeleteKey", "DELETE FROM {0} WHERE (p = {1})"},
    { "dropInsertKey", ""},
    { "createInsertKey", ""},
    { "callInsertKey", ""},
    { "InsertKey", "INSERT INTO {0} VALUES ({1})"},
    { "dropSelectKey", ""},
    { "createSelectKey", ""},
    { "callSelectKey", ""},
    { "SelectKey", "SELECT p FROM {0} WHERE ({1})"},
    { "dropDropKey", ""},
    { "createDropKey", ""},
    { "callDropKey", ""},
    { "DropKey", "DROP TABLE {0} "},
	  // EVENTS
	  // ======
		{ "dropEVENT",            " DROP TABLE Event " },
    { "createEVENT",          " CREATE TABLE Event ( "+
						                    " pProducer INTEGER, " +                          // 0 Producer Key
						                    " pConsumer INTEGER, " +                          // 1 Consumer Key
						                    " pEvent INTEGER, " +                             // 2 Event Key
						                    " state INTEGER, " +                              // 3 Kind of Event (0 = pattern, 1 = new, ...)
						                    " tsCreated LONG NOT NULL)" },                    // 4 timestamp
    { "deleteTestEvents", "DELETE FROM Event WHERE (pProducer >= "+String.valueOf(BeanBroker.PUBLIC_ID*BeanBroker.ID_HIGH)+") and (pProducer < "+String.valueOf((1+BeanBroker.PUBLIC_ID)*BeanBroker.ID_HIGH)+ ") "},
    { "dropInsertEvent", ""},
    { "createInsertEvent", ""},
    { "callInsertEvent", ""},
		{ "InsertEvent",          " INSERT INTO Event VALUES ({0}) " },
		{ "InsertEvent2",          " INSERT INTO Event VALUES ({0}, {1}, {2}, {3}, {4}) " },
    { "dropUpdateEvent", ""},
    { "createUpdateEvent", ""},
    { "callUpdateEvent", ""},
		{ "UpdateEvent",          " UPDATE Event SET pEvent = {0} WHERE pProducer = {1} AND pConsumer = {2} AND pEvent = {3} AND state = {4} " },
    { "dropDeleteEvent", ""},
    { "createDeleteEvent", ""},
    { "callDeleteEvent", ""},
		{ "DeleteEvent",          " DELETE FROM Event WHERE {0} " },
    { "dropSelectEvent", ""},
    { "createSelectEvent", ""},
    { "callSelectEvent", ""},
		{ "SelectEvent",          " SELECT * FROM Event WHERE {0} " },
    { "SelectAllEvents", "SELECT * FROM Event " },
	};

}
