/**
 * SQL Resources for Oracle 8 SQL Server
 * This file is part of Skid
 * (P) 1999 by Klaus Hammermller, klaus@ifs.tuwien.ac.at
 * http://www.ifs.tuwien.ac.at/~hammer
 *
 *@author KH
 *@created 060499 KH
 */
package asgaard.skid.resources;

import java.util.*;

public class SQLRes_Oracle_8 extends SQLRes {

	public Object[][] getContents() {
		return contents;
	}

	static Object[][] contents = {
    { "dateFormat",           " ALTER SESSION SET NLS_DATE_FORMAT = \"YYYY/MM/DD\" " },
    { "dropInsertBean",   " DROP PROCEDURE InsertBean " },
    { "createInsertBean", " CREATE PROCEDURE InsertBean ( IN pKey INTEGER, " +
                   					  "   IN classKey INTEGER, " +
                   					  "   IN parentKey INTEGER, " +
                   					  "   IN autorKey INTEGER, " +
                   					  "   IN ownerKey INTEGER, " +
                   					  "   IN tsCre  DECIMAL(19, 0), " +
                   					  "   IN tsMod  DECIMAL(19, 0), " +
                   					  "   IN tsLnk  DECIMAL(19, 0), " +
                   					  "   IN tsClo  DECIMAL(19, 0), " +
                   					  "   IN typeAttr INTEGER, " +
                   					  "   IN accessAttr INTEGER, " +
                   					  "   IN nameAttr VARCHAR2(26), " +
                   					  "   IN objectAttr VARCHAR) " +
                   					  " BEGIN " +
                   					  "   INSERT INTO Bean VALUES ( pKey, " +
              						    "				                          classKey, " +
              						    "				                          parentKey, " +
              						    "				                          autorKey, " +
              						    "				                          ownerKey, " +
              						    "				                          tsCre, " +
              						    "				                          tsMod, " +
              						    "				                          tsLnk, " +
              						    "				                          tsClo, " +
              						    "				                          typeAttr, " +
              						    "				                          accessAttr, " +
              						    "				                          nameAttr, " +
              						    "				                          objectAttr); " +
              						    "	END " },
    { "callInsertBean",   "{ call InsertBean (?,?,?,?,?,?,?,?,?,?,?) }"},
    { "dropUpdateBean",   " DROP PROCEDURE UpdateBean " },
    { "createUpdateBean", " CREATE PROCEDURE UpdateBean ( IN primKey INTEGER, " +
                   					  "   IN autorKey INTEGER, " +
                   					  "   IN ownerKey INTEGER, " +
                   					  "   IN tsMod  DECIMAL(19, 0), " +
                   					  "   IN tsLnk  DECIMAL(19, 0), " +
                   					  "   IN tsClo  DECIMAL(19, 0), " +
                   					  "   IN typeAttr INTEGER, " +
                   					  "   IN accessAttr INTEGER, " +
                   					  "   IN nameAttr VARCHAR2(26), " +
                   					  "   IN objectAttr VARCHAR) " +
                   					  " BEGIN " +
                   					  "   UPDATE Bean  SET ObjAutor = autorKey, " +
                   					  "          		           Objowner = ownerKey, " +
                   					  "          		           TSmodified = tsMod, " +
                   					  "          		           TSclosed = tsClo, " +
                   					  "          		           ObjType = typeAttr, " +
                   					  "          		           ObjAccess = accessAttr, " +
                   					  "          		           ObjName = nameAttr, " +
                   					  "          		           ObjAttribut = objectAttr " +
                   					  "   WHERE p = primKey; " +
                   					  " END " },
    { "callUpdateBean",   "{ call UpdateBean (?,?,?,?,?,?,?,?,?) }" },
    { "dropSelectBean",   " DROP PROCEDURE SelectBean " },
    { "createSelectBean", " CREATE PROCEDURE SelectBean( IN primKey INTEGER ) " +
                   					  "   RESULT ( BeanKey INTEGER, " +
                   					  "            classKey INTEGER, " +
                   					  "            parentKey INTEGER, " +
                   					  "            autorKey INTEGER, " +
                   					  "            ownerKey INTEGER, " +
                   					  "            tsCre  DECIMAL(19, 0), " +
                   					  "            tsMod  DECIMAL(19, 0), " +
                   					  "            tsLnk  DECIMAL(19, 0), " +
                   					  "            tsClo  DECIMAL(19, 0), " +
                   					  "            typeAttr INTEGER, " +
                   					  "            accessAttr INTEGER, " +
                   					  "            nameAttr VARCHAR2(26), " +
                   					  "            objectAttr VARCHAR) " +
                   					  " BEGIN " +
                   					  "   SELECT * FROM Bean WHERE p = primKey; " +
                   					  " END " },
    { "callSelectBean",   "{ call SelectBean (?) }" }
	};

}
