/**
 * SQL Resources
 * This file is part of Skid
 * (P) 1999 by Klaus Hammermller, klaus@ifs.tuwien.ac.at
 * http://www.ifs.tuwien.ac.at/~hammer
 *
 *@author KH
 *@created 200599 KH
 */

package asgaard.skid.resources;

import java.util.*;

public class SQLRes_mysql extends SQLRes {

	public Object[][] getContents() {
		return contents;
	}

	static Object[][] contents = {
    { "TINYINT",        "TINYINT" },
    { "SMALLINT",       "SMALLINT" },
    { "INTEGER",        "INTEGER" },
    { "BIGINT",         "BIGINT" },
    { "NUMERIC",        "FLOAT" },
    { "DECIMAL",        "FLOAT" },
    { "FLOAT",          "FLOAT" },
    { "REAL",           "REAL" },
    { "DOUBLE",         "DOUBLE" },
    { "CHAR",           "CHAR(1)" },
    { "VARCHAR",        "TEXT" },
    { "LONGVARCHAR",    "LONGTEXT" },
    { "LONGVARBINARY",  "LONGBLOB" },
    { "VARBINARY",      "BLOB" },
    { "BINARY",         "BLOB" },

		{ "dropCKEY",        " DROP IF EXISTS TABLE cKey " },
    { "createCKEY",      " CREATE TABLE cKey ( " +
                                " nr INTEGER, " +
                                " k INTEGER ) " },
		{ "dropUSER",        " DROP TABLE IF EXISTS user " },
    { "createUSER",      " CREATE TABLE user (" +
	      					              " name TINYTEXT, " +                     // 0 User-Name
	      					              " encr TINYTEXT, " +                     // 1 encrypted password
                                " status TINYTEXT, " +                   // 2 status 0 <= active, <0 deleted
                                " p INTEGER, " +                         // 3 person#
                                " language TINYTEXT, " +                 // 4 language
                                " eMail TINYTEXT, " +                    // 5 email
                                " url TINYTEXT, " +                      // 6 url
						                    " tsRegistered BIGINT, " +               // 7 timestamp
						                    " tsExpires BIGINT, " +                  // 8 timestamp
						                    " tsEnded BIGINT) " },                   // 9 timestamp
    { "dropBean",             " DROP TABLE IF EXISTS Bean " },
    { "createBean",           " CREATE TABLE Bean ( " +
						                    " p INTEGER, " +                         // 0 Primary Key
						                    " pClass INTEGER, " +                    // 1 Class Key
						                    " tsCreated BIGINT, " +                  // 2 timestamp
						                    " tsModified BIGINT, " +                 // 3 timestamp
	      					              " identifier TEXT, " +                   // 4 Long Name (automatically generated)
	      					              " name TINYTEXT, " +                     // 5 Short Name
						                    " beantype TINYINT, " +                  // 6 Type of Bean
      						              " skidbean LONGTEXT)" },                 // 7 The Bean
    { "selectRunningNr", "SELECT max(p) as nr FROM Bean WHERE (p >= {0}) and (p < {1}) " },
    { "dropLINK",         " DROP TABLE IF EXISTS Link " },
    { "createLINK",        " CREATE TABLE Link ( " +
						                    " pFrom INTEGER, " +                     // 0 FROM
                                " nr INTEGER, " +                        // 1 (not part of the key!)
						                    " pTo INTEGER, " +                       // 2 TO
						                    " pBy INTEGER, " +                       // 3 RELATE
						                    " tsCreated BIGINT, " +                  // 4 timestamp
						                    " tsModified BIGINT, " +                 // 5 timestamp
						                    " tsBegin BIGINT, " +                    // 6 timestamp
						                    " tsEnd BIGINT, " +                      // 7 timestamp
			      			              " state INTEGER )" },                    // 8 read/add/mod/exec for system/owner/creator/group/other
    { "DropKey", "DROP TABLE IF EXISTS {0} "},
		{ "dropEVENT",            " DROP TABLE IF EXISTS Event " },
    { "createEVENT",          " CREATE TABLE Event ( "+
						                    " pProducer INTEGER, " +                 // 0 Producer Key
						                    " pConsumer INTEGER, " +                 // 1 Consumer Key
						                    " pEvent INTEGER, " +                    // 2 Event Key
						                    " state INTEGER, " +                     // 3 Kind of Event (0 = pattern, 1 = new, ...)
						                    " tsCreated BIGINT)" }                   // 4 timestamp
	};

}
