package asgaard.test.encode;

import java.io.*;
import asgaard.utils.encode.*;

public class SniffFileOutputStream extends FileOutputStream {

  private HexEncOutputStream snif = new HexEncOutputStream( );
  private FileWriter snifout;
  private String memo;
  private int counter = 0;

  public SniffFileOutputStream(String file, String filename, String memo ) throws IOException {
    super( file );
    this.memo = memo;
    snifout = new FileWriter( filename );
    writeln();
  }

  public void writeln() throws IOException {
    if (snifout != null)
      snifout.write( memo +"(" + String.valueOf(counter) + ")" + snif.readBuffer() + "\n" );
    counter++;
  }

  public void write(int b) throws IOException {
//    snif.write( b - 128 );
    snif.write( b );
    super.write( b );
  }
  public void write(byte b[]) throws IOException {
//    for (int i=0; i<b.length; i++)
//      snif.write( b[i] - 128 );
    snif.write( b );
    super.write( b );
  }
  public void write(byte b[], int off, int len) throws IOException {
//    for (int i=off; i<(off+len); i++)
//      snif.write( b[i] - 128 );
    snif.write( b, off, len );
    super.write( b, off, len );
  }
  public void close() throws IOException {
    super.close();
    writeln();
    snifout.close();
  }
}