/**
 *@autor    Klaus Hammermller
 *@created  030398
 */


package asgaard.utils.encode;
import java.io.OutputStream;
import java.io.IOException;

public abstract class CodedOutputStream extends OutputStream {

  protected OutputStream out;
  protected String buf = "";
  protected boolean holdbuf = true;

  /**
   * Creates the Stream.
   */
  public CodedOutputStream( ) {
  }
  /**
   * Creates the Stream.
   */
  public CodedOutputStream( OutputStream output ) {
    setOutputStream( output );
  }
  /**
   * Set the coded data and sends it to the connected OutputStream.
   */
  public void setCoded( String s ) throws IOException {
    for(int i = 0; i < s.length(); i++ )
      write( (int) s.charAt(i) - 128 );
  }

  /**
   * Let us see what was passing bye ...
   */
  public String readBuffer( ) throws IOException {
    String str = new String( buf );
    buf = "";
    return str;
  }

  /**
   * Set the OutputStream.
   */
  public void setOutputStream( OutputStream output ) {
    out = output;
  }

  /**
   * Flushes this output stream and forces any buffered output bytes to be written out.
   */
  public void flush() throws IOException {
    if (out != null) out.flush();
  }

  /**
   * Closes this output stream and releases any system resources associated with this stream.
   */
  public void close() throws IOException {
    if (out != null) out.close();
  }
}
