/**
 *@autor    Klaus Hammermller
 *@created  030299
 */

package asgaard.utils.encode;
import java.io.IOException;
import java.io.OutputStream;

   /**
     * Converts bytes to a ASCII-HEX-String
     */
public class HexEncOutputStream extends CodedOutputStream {

    private static final String tab = "0123456789ABCDEF";
    private char c0;
    private char c1;

    /**
     * Creates the Stream.
     */
    public HexEncOutputStream( ) {
    }
    /**
     * Creates the Stream.
     */
    public HexEncOutputStream( OutputStream output ) {
      setOutputStream( output );
    }
    /**
     * Writes the specified byte to this output stream
     *
     *@param b the byte to be written.
     */
    public void write(int b) throws IOException {
      int i = (b + 256) % 256;
      c0 = tab.charAt( i >>> 4 );               //SHR 4
      c1 = tab.charAt( i & 15 );                //Mask LSB
      if (holdbuf) {
        buf += c0;
        buf += c1;
      }
      if (out != null) {
        out.write( (byte) c0 );
        out.write( (byte) c1 );
      }
    }
}

