/**
 *@autor    Klaus Hammermller
 *@created  030398
 */


package asgaard.utils.encode;
import java.lang.*;
import java.io.*;

/**
 * Is a Decoder, using <code>HexDecInputStream</code> to decode an object
 * encoded by <code>ObjectEncoder</code>.
 *
 *@see asgaard.utils.encode.HexEncOutputStream
 *@see asgaard.utils.encode.ObjectEncoder
 */
public class ObjectDecoder {

  private CodedInputStream dec;       // The Decoder Stream
  private ObjectInputStream oi;       // The input-Stream
  private static final String magic = "ACED0005";

  /**
   * Creates a new Decoder.
   */
  public ObjectDecoder(  ) {
    try {
      dec = new HexDecInputStream();
      dec.writeBuffer( magic );
      oi = new ObjectInputStream( dec );
    } catch (Exception e) {
      System.err.println(e.toString() + " " + e.getMessage());
    }
  }

  /**
   * Set the encoded data.
   */
  public void setEncoded( String s ) throws IOException {
    if ( s.startsWith( magic ) )
      dec.writeBuffer( s.substring( magic.length(), s.length() ));
    else
      dec.writeBuffer( s );
  }

  /**
   * Get the decoded Object.
   */
  public Object getObject( ) throws IOException, ClassNotFoundException {
    return oi.readObject();
  }
}