// This class is part of Skid
//@autor  (P) by Klaus Hammermller, mailto:klaus@ifs.tuwien.ac.at
//@version	1.0 040699
//
//@created	040699  KH
package asgaard.utils.unit;

/**
 * This Class carries the conversion of a measure from it's native form
 * (in the base-unit exmpl iso "meter" for distance) to a customized unit
 * (exmpl "mile")
 */
public class LinearScaling implements Convert {

  /**
   * For linear scaling
   */
  protected float multiplier = 1;

  /**
   * Instanciates an converter with a neutral multiplier (1).
   */
  public LinearScaling() { }

  /**
   * Instanciates an converter
   *@param scal a liniar multiplier
   */
  public LinearScaling(float scale) {
    multiplier = scale;
  }

  /**
   * Returns the measure in the base-unit
   */
  public float getBaseMeasure(float customMeasure) {
    return customMeasure / multiplier;
  }

  /**
   * Returns the measure in the custom-unit
   */
  public float getCustomMeasure(float baseMeasure) {
    return baseMeasure * multiplier;
  }
}
