// This class is part of Banshee using Skid
// Banshee is an implementation from the asgaard-project in the sport-domain
// This file was automatically created from banshee.util.ServletParser at Fri Aug 20 17:54:27 CEST 1999
package banshee;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.rmi.*;
import java.util.*;

import asgaard.skid.*;
import asgaard.utils.log.*;

abstract class MsgServlet extends banshee.Servlet {

  private static boolean readFiles = true;

  protected static String[][] pp_head = {
    {"<html>\n\t<head>\n\t\t<title>Banshee !!</title>\n\t\t<link rel=\"stylesheet\" type=\"text/css\"; href=\"http://128.130.167.56:90/asgaard/banshee.main/banshee.css\">\n\t</head>\n\t<BODY background=\"http://128.130.167.56:90/asgaard/banshee.main/background.jpg\" bgcolor=\"#FFFFFF\">"},
  };

  protected static String[][] pp_foot = {
    {"</BODY>\n\t\t</HTML>"},
  };

  protected static String[][] pp_trailer = {
    {"<hr size=\"1\" noshade>\n\t\t\t<P><CENTER><FONT size=\"1\">\n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/asgaard\">", "ENG", "GER"},
    {"</A> &nbsp; \n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/help.html\">",
			"Experimental Site of the Asgaard-project",
			"Experimental Site des Asgaard-Projekts"},
    {"</A>  &nbsp; \n\t\t\t\t<A href=\"mailto:klaus@ifs.tuwien.ac.at\">",
			"Help",
			"Hilfe"},
    {"</A>  &nbsp; \n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/jobs.html\">",
			"Feedback",
			"Feedback"},
    {"</A></FONT></CENTER></P>",
			"Jobs",
			"Jobs"},
  };

  protected static String[][] ssl_error = {
    {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n\t<html>\n\t\t<head>\n\t\t\t<meta http-equiv=\"Content-Type\" content=\"text/html\">\n\t\t\t<title>", "ENG", "GER"},
    {"</title>\n\t\t\t<link rel=\"stylesheet\" type=\"text/css\"; href=\"http://128.130.167.56:90/asgaard/banshee.main/banshee.css\">\n\t\t</head>\n\t\t<BODY background=\"http://128.130.167.56:90/asgaard/banshee.logon/background.jpg\" bgcolor=\"#FFFFFF\">\n\t\t\t<img src=\"http://128.130.167.56:90/asgaard/banshee.logon/banshee-small.jpg\" border=\"0\" alt=\"Banshee\">\n\t\t\t<hr size=\"1\" noshade>\n\t\t\t<h1><center><font color=\"#FF0000\">",
			"Banshee Error",
			"Banshee Fehler"},
    {"</font></center></h1>\n\t\t\t<h3><center>",
			"Sorry - we only support SSL!",
			"Sorry - die SSL Verbindung ist gescheitert!"},
    {"</center></h3>\n\t\t\t<p align=\"left\"><font size=\"3\">",
			"A Secure Socket Layer connection is required.",
			"Wir ben&ouml;tigen eine Secure Socket Layer SSL Verbindung."},
    {"<br>",
			"To ensure the safety of your data we only support Secure Socket Layer (SSL) connections, which has to be supported by your browser too.",
			"Um die Sicherheit Ihrer Daten garantieren zu k&ouml;nnen, m&uuml;ssen wir eine Secure Socket Layer Verbindung verlangen, die auch in Ihrem Browser implementiert sein mu&szlig;."},
    {"</font></p>\n\t\t\t<form action=\"http://128.130.167.56:90/asgaard/banshee.logon\" method=\"POST\">\n\t\t\t\t<input type=\"hidden\" name=\"pid\" value=\"DEBUG\">\n\t\t\t\t<input type=\"hidden\" name=\"lang\" value=\"",
			"We are working hard to make Banshee more comfortable - if nessecary for your need please contact our helpdesk.",
			"Wir arbeiten daran, Banshee noch komfortabler zu machen - wenn notwendig, wenden Sie sich bitte derweilen an unseren Helpdesk."},
    {"\">\n\t\t\t</form>\n\t\t\t<P>\n\t\t\t<hr size=\"1\" noshade>\n\t\t\t<P><CENTER><FONT size=\"1\">\n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/asgaard\">",
			"ENG",
			"GER"},
    {"</A> &nbsp; \n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/help.html\">",
			"Experimental Site of the Asgaard-project",
			"Experimental Site des Asgaard-Projekts"},
    {"</A>  &nbsp; \n\t\t\t\t<A href=\"mailto:klaus@ifs.tuwien.ac.at\">",
			"Help",
			"Hilfe"},
    {"</A>  &nbsp; \n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/jobs.html\">",
			"Feedback",
			"Feedback"},
    {"</A></FONT></CENTER></P>\n\t\t</BODY>\n\t</HTML>",
			"Jobs",
			"Jobs"},
  };

  protected static String[][] conn_err = {
    {"<img src=\"http://128.130.167.56:90/asgaard/banshee.logon/banshee-small.jpg\" border=\"0\" alt=\"Banshee\">\n\t\t\t<hr size=\"1\" noshade>\n\t\t\t<h1><center><font color=\"#FF0000\">", "ENG", "GER"},
    {"</font></center></h1>\n\t\t\t<h3><center>",
			"Sorry - your connection became invalid!",
			"Sorry - Ihre Verbindung wurde ung&uuml;ltig!"},
    {"</center></h3>\n\t\t\t<p align=\"left\"><font size=\"3\">",
			"Please re-login again!",
			"Bitte melden Sie sich erneut an!"},
    {"<br>",
			"Because of an time out your connection became invalid to ensure safety of Banshee.",
			"Wegen einer Zeit&uuml;berschreitung wurde Ihre Verbindung ungltig um die Sicherheit von Banshee garantieren zu k&ouml;nnen."},
    {"</font></p>\n\t\t\t<P>\n\t\t\t<hr size=\"1\" noshade>",
			"We are working hard to make Banshee more comfortable - if nessecary for your need please contact our helpdesk.",
			"Wir arbeiten daran, Banshee noch komfortabler zu machen - wenn notwendig, wenden Sie sich bitte derweilen an unseren Helpdesk."},
  };

  protected static String[][] not_implemented_yet = {
    {ssl_error[0][0], "ENG", "GER"},
    {ssl_error[1][0],
			ssl_error[1][1],
			ssl_error[1][2]},
    {ssl_error[2][0],
			"Sorry - function not available!",
			"Sorry - diese Funktion ist nicht verf&uuml;gbar!"},
    {ssl_error[3][0],
			"The requested function has not been released yet.",
			"Die angeforderte Funktion wurde noch nicht freigegeben."},
    {ssl_error[4][0],
			"Until this is an early research-prototype this function has not been released for public use.",
			"Da dies ein Forschungs-Prototyp ist, wurden noch nicht alle Funktionen f&uuml;r den &ouml;ffentlichen Gebrauch zug&auml;nglich gemacht."},
    {ssl_error[5][0],
			ssl_error[5][1],
			ssl_error[5][2]},
    {ssl_error[6][0],
			ssl_error[6][1],
			ssl_error[6][2]},
    {ssl_error[7][0],
			ssl_error[7][1],
			ssl_error[7][2]},
    {ssl_error[8][0],
			ssl_error[8][1],
			ssl_error[8][2]},
    {ssl_error[9][0],
			ssl_error[9][1],
			ssl_error[9][2]},
    {ssl_error[10][0],
			ssl_error[10][1],
			ssl_error[10][2]},
  };

  protected static String[][] db_error = {
    {ssl_error[0][0], "ENG", "GER"},
    {ssl_error[1][0],
			ssl_error[1][1],
			ssl_error[1][2]},
    {ssl_error[2][0],
			"Sorry - database offline!",
			"Sorry - die Datenbank ist momentan nicht verf&uuml;gbar!"},
    {ssl_error[3][0],
			"The database could not be reached - please try again later.",
			"Die Datenbank konnte nicht erreicht werden - bitte versuchen Sie es sp&auml;ter noch einmal."},
    {ssl_error[4][0],
			"Because of some maintainance work the database is currently offline.",
			"Wegen Wartungsarbeiten mu&szlig;te die Datenbank zeitweilig vom Netz genommen werden."},
    {ssl_error[5][0],
			ssl_error[5][1],
			ssl_error[5][2]},
    {ssl_error[6][0],
			ssl_error[6][1],
			ssl_error[6][2]},
    {ssl_error[7][0],
			ssl_error[7][1],
			ssl_error[7][2]},
    {ssl_error[8][0],
			ssl_error[8][1],
			ssl_error[8][2]},
    {ssl_error[9][0],
			ssl_error[9][1],
			ssl_error[9][2]},
    {ssl_error[10][0],
			ssl_error[10][1],
			ssl_error[10][2]},
  };

  protected static String[][] debug_msg = {
    {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n\t<html>\n\t\t<head>\n\t\t\t<meta http-equiv=\"Content-Type\" content=\"text/html\">\n\t\t\t<title>", "ENG"},
    {"</title>\n\t\t\t<link rel=\"stylesheet\" type=\"text/css\"; href=\"http://128.130.167.56:90/asgaard/banshee.main/banshee.css\">\n\t\t</head>\n\t\t<BODY background=\"http://128.130.167.56:90/asgaard/banshee.logon/background.jpg\" bgcolor=\"#FFFFFF\">\n\t\t\t<img src=\"http://128.130.167.56:90/asgaard/banshee.logon/banshee-small.jpg\" border=\"0\" alt=\"Banshee\">\n\t\t\t<hr size=\"1\" noshade>\n\t\t\t<h1><center><font color=\"#FF0000\">",
			"Banshee Debug Message"},
    {"</font></center></h1>\n\t\t\t<h3><center>",
			"Banshee Debug Message"},
    {"</center></h3>\n\t\t\t<p align=\"left\"><font size=\"3\">",
			"Banshee Debug Message"},
    {"<br>",
			"Banshee Debug Message"},
    {"</font></p>\n\t\t\t<form action=\"http://128.130.167.56:90/asgaard/banshee.logon\" method=\"POST\">\n\t\t\t\t<input type=\"hidden\" name=\"pid\" value=\"NIY\">\n\t\t\t\t<input type=\"hidden\" name=\"lang\" value=\"",
			"Banshee Debug Message"},
    {"\">\n\t\t\t</form>\n\t\t\t<P>\n\t\t\t<h3><center>",
			"ENG"},
    {"&nbsp;<A href=\"mailto:klaus@ifs.tuwien.ac.at\">",
			"Pardon! It was never intendet that you see this message - please report to our"},
    {"</A></center></h3>\n\t\t\t<hr size=\"1\" noshade>\n\t\t</BODY>\n\t</HTML>",
			"development hotline."},
  };

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    if (readFiles) {
      readFiles = false;
      try {
        readBinary("/banshee.css");
        readBinary("/background.jpg");
        readBinary("/banshee-small.jpg");
      } catch (Exception e) { }
    }
  }

  /**
   * Processes the HTTP request GET.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    String uri = request.getRequestURI();
		if (uri.endsWith("/banshee.css")) {
			out(response, "text/css", "/banshee.css");
	} else if (uri.endsWith("/background.jpg")) {
			out(response, "image/jpg", "/background.jpg");
	} else if (uri.endsWith("/banshee-small.jpg")) {
			out(response, "image/jpg", "/banshee-small.jpg");
	} else 
		;
	  super.doGet(request, response);
	}

  /**
   * Gets the UserSession if not currently existing and sets the user-Language
   */
  protected boolean userValid(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException  {

			try {
				if ((! debug) && (! "https".equals (request.getScheme ()))) {
					logMsg( this.getClass().getName() , "userValid#0", LogMsg.LOG_SECURITY, false, "SSL error at ["+request.getRemoteAddr()+"]");
					out( response, "text/html", ssl_error, lang );
					return false;
				} else {
					boolean ok = userValid(request);
					if (!ok) {
						logMsg( this.getClass().getName() , "userValid#1", LogMsg.LOG_SECURITY, false, "page-id fault at ["+request.getRemoteAddr()+"]");
						PrintWriter o = open(response, "text/html");
						out( o, pp_head, lang);
						out( o, conn_err, lang);
						(new logon()).writePage(o, lang);
						out( o, pp_trailer, lang);
						out( o, pp_foot, lang);
						close(o);
					}
					return ok;
				}
			} catch (Exception e) {
				logMsg( this.getClass().getName() , "userValid#2", LogMsg.LOG_SECURITY, false, "fault >"+e.toString()+"< at ["+request.getRemoteAddr()+"]");
				PrintWriter o = open(response, "text/html");
				out( o, pp_head, lang);
				out( o, conn_err, lang);
				(new logon()).writePage(o, lang);
				out( o, pp_trailer, lang);
				out( o, pp_foot, lang);
				close(o);
				return false;
			}
		
  }

  /**
   * Checks if the databaseconnection should be valid
   */
  protected boolean dbValid(HttpServletResponse response) throws ServletException, IOException  {

			if (skidOffline)
				connectSkid();
			if (skidOffline)
				out( response, "text/html", db_error, lang );
			return !skidOffline;
		
  }

  public String getServletInfo() {
    return "banshee.MsgServlet service Information";
  }
}