package banshee;

import java.rmi.*;
import asgaard.skid.*;
import asgaard.utils.test.*;

/**
 * This Class is a the Test-class for the asgaard.skid package.
 */
public class TestBanshee extends TestSkid {

    private static Integer i0 = new Integer(0);


    public final static Object[][] TESTSCRIPT_BANSHEE = {
      { TEST_METHOD_LOCAL, "getUserParam#1", "getUserParams", null },
      { TEST_METHOD_LOCAL, "setUserParam#1", "setUserParams", new Object[] {Test.RES_OBJ+"newUserSession#1", Test.RES_OBJ+"getUserParam#1"} },
    };
//        UserSession u = new UserSession("klaus", "sgdh", host);
//        setUserParams(u, getUserParams());

	protected RemoteBroker skid;

  /**
   * Creates a new Test-Instance
   */
  public TestBanshee() {
    local_object = this;
  }

  /**
   * Main-Methode
   */
  public static void main(String[] args) {
    System.out.println("Hello, this is banshee.Test, checking the asgaard.skid package.");
    System.out.println("Usage: java banshee.TestBanshee <host>");
    if (args.length < 1) {
      System.out.println("parameter missing: e.g. 128.130.167.57");
      System.exit( 0 );
    }
    TestBanshee app = new TestBanshee();
    try {
			BeanBroker.THIS = (RemoteBroker) Naming.lookup("//"+args[0] +"/"+ Skid.ServerName);
      BeanBroker.HOST = args[0];
      System.out.println("Connect to //" + args[0] +"/"+ Skid.ServerName);
    } catch (Exception e) {
      System.err.println("Could not connect to //" + args[0] +"/"+ Skid.ServerName);
      System.err.println(e.toString());
      e.printStackTrace();
      System.exit( 0 );
    }
    app.testIt(app);
  }

  /**
   * Returns a collection of all Testscripts
   */
  public Object[][] getTestScript() {
//    return concatScripts(new Object[] { super.getTestScript(), TestBanshee.TESTSCRIPT_BANSHEE });
return TestBanshee.TESTSCRIPT_BANSHEE;
  }

  public String[] getUserParams()  {

			String[] params = {
				 "D" ,
				 "ALIAS" ,
				 "xxxx" ,
				 "xxxx" ,
				 "H" ,
				 "W" ,
				 "M" ,
				 "FIRSTNAME" ,
				 "LASTNAME" ,
				 "1" ,
				 "1" ,
				 "1990" ,
				 "klaus@ifs.tuwien.ac.at" ,
				 "HOMEPAGE" ,
				 "SW" ,
				 "F" ,
				 "CLUB" ,
				 "C" ,
				 "1111",
				 "DE" ,
				 "S",
				 "0",
				 "-",
				 "ST" ,
				 "D" ,
				 "PC" ,
				 "C" };
			return params;

  }

  public boolean setUserParams(UserSession aUser, String[] params)  {

			banshee.lang.Person person = null;
			try {
				person = (banshee.lang.Person) BeanBroker.THIS.getBean((int) aUser.getKey());
				if (person == null)
					person = new banshee.lang.Person();
			} catch (Exception e) {
				person = new banshee.lang.Person();
			}
			boolean accepted = true;
			try {
				person.setNation(params[19]);
				person.setSex(params[6]);
				person.setFirstname(params[7]);
				person.setLastname(params[8]);
				person.setNickname(params[1]);
				person.setBirthdate(getGebDat(params[11], params[10], params[9]));
				person.setSport(params[14]);
				person.setMotivation(params[15]);
				person.setClub(params[16]);
				person.setFunction(params[17]);
				person.setZIP(params[18]);
				person.setCountry(params[19]);
				person.setFamily(params[20]);
				person.setChildren(params[21]);
				person.setEducation(params[22]);
				person.setBusiness(params[23]);
				person.setComputerskills(params[24]);
				person.setEquipment(params[25]);
				person.setConnection(params[26]);
				person.flush();
			} catch (Exception e) {
        System.err.println(e.toString());
        e.printStackTrace();
				accepted = false;                   
			}
			aUser.setName(params[1]);
			if (params[2].length() > 0)
				accepted = accepted && aUser.setPwd(params[2], params[2]);
			accepted = accepted && aUser.setLanguage("GER", banshee.Servlet.LANGUAGES);
			accepted = accepted && aUser.setEMail(params[12]);
			accepted = accepted && aUser.setURL(params[13]);
			if (params[4].equalsIgnoreCase("HTML"))
				aUser.addStatus( UserSession.STATUS_REPLY_HTML );
			if (params[5].equalsIgnoreCase("7"))
				aUser.addStatus( UserSession.STATUS_REPLY_WEEKLY );
			try {
  				accepted = accepted && aUser.setKey(person.getKey());
			} catch (Exception ex) { }
			try {
  				aUser.save( );
			} catch (Exception ey) {
				accepted = false;
			}
			return accepted;
		
  }

  private java.util.Date getGebDat(String year, String month, String date)  {

			try {
				 java.util.GregorianCalendar geb = new java.util.GregorianCalendar (Integer.parseInt(year),
									Integer.parseInt(month),
									Integer.parseInt(date));
				 return geb.getTime();
			} catch (Exception eg) {
				return null;
			}
		
  }
}

