// This class is part of Banshee using Skid
// Banshee is an implementation from the asgaard-project in the sport-domain
//@autor  (P) by Klaus Hammermller, mailto:klaus@ifs.tuwien.ac.at
//@version	1.0 260599
//
//@created	260599  KH
package banshee.lang;

// Import the skid-API
import asgaard.skid.*;
import asgaard.lang.*;

/**
 * This class holds a individual configuration of a typical action in workout.
 * Individual means, different sports(wo)men have different "defaults" with their
 * Training but uses them as a typical pattern whith their workout very often.
 * These templates are used by their Entries which documentate an action in workout.
 *
 *@see asgaard.banshee.lang.Entry
 */
public class Template extends Entity {

  /**
   * The keys to get the Items from Skid
   */
  protected int[] iKeys;

  /**
   * Instanciates a Template
   *@throws Exception
   */
  public Template() throws Exception {
    for (int i=0;i<iKeys.length;i++) {
      items[i] = (Item) broker.getBean(iKeys[i]);
    }
  }

  /**
   * Returns the Template used by this Action
   *@returns the Template itselfe (<code>this</code>)
   */
  public Entity getTemplate() {
    return this;
  }

  /**
   * Returns the Item-List
   */
  public Item[] getItems() {
    return items;
  }

  /**
   * Returns the Defaults
   */
  public Object[] getDefaults() {
    return values;
  }

}