// This class is part of Banshee using Skid
// Banshee is an implementation from the asgaard-project in the sport-domain
// This file was automatically created from banshee.util.ServletParser at Fri Aug 20 17:54:01 CEST 1999
package banshee;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.rmi.*;
import java.util.*;

import asgaard.skid.*;
import asgaard.utils.log.*;

public final class logon extends banshee.MsgServlet {

  private static boolean readFiles = true;

  protected static String[][] pp_error1 = {
    {"<html>\n\t\t<head>\n\n\t\t\t<meta http-equiv=\"Content-Type\" content=\"text/html\">\n\n\t\t\t<title>", "ENG", "GER"},
    {"</title>\n\n\t\t\t<link rel=stylesheet type=\"text/css\"; href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/banshee.css\">\n\t\t</head>\n\n\t\t<BODY background=\"http://128.130.167.56:90/asgaard/banshee.logon/background.jpg\" bgcolor=\"#FFFFFF\">\n\t\t\t<img src=\"http://128.130.167.56:90/asgaard/banshee.logon/banshee-small.jpg\" border=\"0\" alt=\"Banshee\">\n\t\t\t<hr size=\"1\" noshade>\n\t\t\t<h1><center><font color=\"#FF0000\">",
			"Banshee Error",
			"Banshee Fehler"},
    {"</font></center></h1>\n\n\t\t\t<h3><center>",
			"An error occoured!",
			"Ein Fehler ist aufgetreten!"},
    {"</center></h3>\n\n\t\t\t<p align=\"left\"><font size=\"3\">",
			"invalid entry",
			"Ung&uuml;ltige Eingabe"},
    {"<br>",
			"Please retry the entry of your username and password again!",
			"Bitte versuchen Sie die Eingabe Ihrer Kennung und Ihres Pa&szlig;worts erneut."},
    {"</font></p>",
			"This page was delayed for 3 seconeds by the Banshee server.",
			"Die Ausgabe dieser Seite wurde von Banshee bewu&szlig;t um 3 Sekunden verz&ouml;gert!"},
  };

  protected static String[][] pp_logon = {
    {"<form action=\"http://128.130.167.56:90/asgaard/banshee.logon\" method=\"POST\" target=\"_top\">\n\t\t\t<input type=\"hidden\" name=\"pid\" value=\"RETRY\">\n\t\t\t<input type=\"hidden\" name=\"lang\" value=\"", "ENG", "GER"},
    {"\">\n\t\t\t<table border=\"0\" cellpadding=\"5\" cellspacing=\"5\">\n\n\t\t\t<tr>\n\n\t\t\t\t<td>",
			"ENG",
			"GER"},
    {"</td>\n\n\t\t\t\t<td nowrap><input type=\"text\" size=\"30\" name=\"id\"></td></tr>\n\n\t\t\t<tr>\n\n\t\t\t\t<td>",
			"Your Banshee-user:",
			"Ihre Banshee-Kennung:"},
    {"</td>\n\n\t\t\t\t<td nowrap><input type=\"password\" size=\"30\" name=\"p\"></td>\n\n\t\t\t\t<td>",
			"Password:",
			"Pa&szlig;wort:"},
    {"</td></tr>\n\n\t\t\t<tr>\n\t\t\t\t<td> &nbsp; </td>\n\t\t\t\t<td> &nbsp; </td>\n\t\t\t\t<td>\t<input type=submit value=\"",
			"(will not be displayed)",
			"(wird nicht angezeigt)"},
    {"\" name=\"nock\">\n\t\t\t\t\t<input type=reset value=\"",
			"Login",
			"Anmelden"},
    {"\"></td></tr>\n\t\t\t</table>\n\t\t\t</form>",
			"Reset",
			"R&uuml;cksetzen"},
    {"&nbsp;<b><a href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/policy.html\">",
			"Whith the login you are accepting the",
			"Mit der Anmeldung akzeptieren Sie die"},
    {"</a></b>",
			"Banshee-Policy",
			"Banshee-Benutzungsbestimmungen"},
  };

  protected static String[][] pp_error2 = {
    {"<hr size=\"1\" noshade>\n\t\t\t<p align=\"left\"><font size=\"3\">", "ENG", "GER"},
    {"<br>",
			"If you've forgotten your password, enter the email address you used when you registered as a Banshee-member, and click submit.",
			"Falls Sie Ihr Pa&szlig;wort vergessen haben, geben Sie uns die e-Mailadresse an, die Sie bei der ersten Anmeldung angegeben haben."},
    {"</font></p>\n\t\t\t<form action=\"http://128.130.167.56:90/asgaard/banshee.logon\" method=\"POST\">\n\t\t\t<input type=\"hidden\" name=\"pid\" value=\"RETRY\">\n\t\t\t<input type=\"hidden\" name=\"lang\" value=\"",
			"We'll send you an e-mail with your password to this e-mail address.",
			"Ihr Kennung und Pa&szlig;wort wird an diese Adresse geschickt."},
    {"\">\n\t\t\t<table border=\"0\" cellpadding=\"5\" cellspacing=\"5\">\n\t\t\t<tr>\n\t\t\t\t<td>",
			"ENG",
			"GER"},
    {"</td>\n\t\t\t\t<td nowrap><input type=\"email\" size=\"30\" name=\"email\"></td>\n\t\t\t\t<td><input type=submit value=\"",
			"e-Mail",
			"e-Mail"},
    {"\"  name=\"ask\"></td></tr>\n\t\t\t</table>\n\t\t\t</form>\n\n\t\t\t<P>\n\t\t\t<hr size=\"1\" noshade>\n\t\t\t<P><CENTER><FONT size=\"1\">\n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/asgaard\">",
			"Submit",
			"Abschicken"},
    {"</A> &nbsp; \n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/help.html\">",
			"Experimental Site of the Asgaard-project",
			"Experimental Site des Asgaard-Projekts"},
    {"</A>  &nbsp; \n\t\t\t\t<A href=\"mailto:klaus@ifs.tuwien.ac.at\">",
			"Help",
			"Hilfe"},
    {"</A>  &nbsp; \n\t\t\t\t<A href=\"http://www.ifs.tuwien.ac.at/~hammer/banshee/jobs.html\">",
			"Feedback",
			"Feedback"},
    {"</A></FONT></CENTER></P>\n\t\t</BODY>\n\t</HTML>",
			"Jobs",
			"Jobs"},
  };

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }

  /**
   * Processes the HTTP request POST, this is the main entrance to Banshee.
   */
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    String uri = request.getRequestURI();
		if (uri.endsWith(".logon")) {
			// SSLSession session = (SSLSession) request.getAttribute ("javax.net.ssl.session");
			try {
				lang = getParameter( request, "lang" );
			} catch (Exception ex) { }	
			if (dbValid( response )) {
				String user = "$";
				try {
					user = getParameter( request, "id" );
					String ip = request.getRemoteAddr();
					currentUser = new UserSession(user, getParameter( request, "p" ), ip);
					logMsg( this.getClass().getName() , "new", LogMsg.LOG_REMARK, currentUser != null, "User >" + user + "< connect from ["+ip+"]" );
					main m = new main();
					m.setSession(this);
					PrintWriter o = open(response, "text/html");
					m.writePage(request, o);
					close(o);
				} catch (Exception e) {
					if (!(e instanceof SkidException)) {
						out( response, "text/html", db_error, getParameter( request, "lang" ));
						logMsg( this.getClass().getName() , "Post#1", LogMsg.LOG_ERROR, false, "DB connection refused " + e.toString());
					} else {
						if (paramExist( request, "ask" ) && (getParameter( request, "email" ).length() > 0)) {
							// check e-Mail and send user & paword
							out( response, "text/html", not_implemented_yet, getParameter( request, "lang" ));
							// logMsg( this.getClass().getName() , "Post#2", LogMsg.LOG_REMARK, true, "Forgotten password sent to >" + user + "< from ["+request.getRemoteAddr()+"]");
						} else {                                          // ERROR : User-check failed
							long now = System.currentTimeMillis();
							while ((now + 3000) < System.currentTimeMillis())
								try{ this.wait(3000); } catch (Exception f) { }
							PrintWriter o = open(response, "text/html");
							out( o, pp_error1, lang);
							writePage(o, lang);
							out( o, pp_error2, lang);
							close(o);
							logMsg( this.getClass().getName() , "Post#3", LogMsg.LOG_REMARK, false, "Wrong password sent from >" + user + "< at ["+request.getRemoteAddr()+"]");
						}
					}
				}
			}
		} else 
		;
	  super.doPost(request, response);
	}

  /**
   * Returns the UserSession by the current login. Only use by the main-servlet.
   */
  UserSession getSession(banshee.main by) throws IllegalAccessException  {

			if (!(by instanceof banshee.main))
				throw new IllegalAccessException("Creator is not an valid main-Servlet");
			return currentUser;
		
  }

  /**
   * Writes the main part of the Serlet's outcome.
   */
  protected void writePage(PrintWriter o, String lang) throws ServletException, IOException  {

			out( o, pp_logon, lang);
		
  }

  public String getServletInfo() {
    return "banshee.logon service Information";
  }
}