// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara

package bonfire;

import com.objectspace.jgl.*;
import java.io.*;

public class BNFParserListNode extends BNFParserNode {
	DList items;

	public BNFParserListNode(int id) {
		super(id);
		items = new DList();
	}
	
	public BNFParserListNode(BNFParser p, int id) {
		super(p, id);
		items = new DList();
	}

	public void setVisited(boolean val, boolean recurse) {
	  visited = val;
	  if (recurse)
		  for (DListIterator it = items.begin(); !it.atEnd(); it.advance())
			  ((BNFParserNode)it.get()).setVisited(val, true);
	}

	public void jjtClose() {
		for (int i=0; i<jjtGetNumChildren(); i++)
			items.add(jjtGetChild(i));
	}
	
	public void resolve(Definition user, BNFParserNode paren) {
		parent = paren;
		for (DListIterator it = items.begin(); !it.equals(items.end()); it.advance())
			((BNFParserNode)it.get()).resolve(user, this);
	}

	public void maketoString(PrintWriter w, int env) {
		for (DListIterator it = items.begin(); !it.atEnd(); it.advance()) {
			BNFParserNode node = (BNFParserNode)it.get();
			node.maketoString(w, env);
			w.println();
		}
	}
	
}
