// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara

package bonfire;

import java.io.*;

class BooleanAttribute extends ClassAttribute {

	public static final int TYPE = -2;
	
	BooleanAttribute(String n, BNFParserNode o) {
		super(n, o);
		typ = "boolean";
	}

	public int getTYPE() {
		return TYPE;
	}

	public void dumpDeclaration(PrintWriter w) {
		dumpDeclaration(w, "boolean", name, "false");
	}

	public void dumpMethods(PrintWriter w, boolean intf) {
		dumpMethods(w, "boolean", name, intf);
	}

	public void dumpParseCode(PrintWriter w) {
		w.print(Bonfire.format("setboolean", name));
	}
}
