// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara

package bonfire;

import java.lang.*;
import java.io.*;

public class CounterAttribute extends ClassAttribute {

	public static final int TYPE = -3;
	
	CounterAttribute(String n, BNFParserNode o) {
		super(n, o);
		typ = "int";
	}

	public int getTYPE() {
		return TYPE;
	}

	public void dumpDeclaration(PrintWriter w) {
		dumpDeclaration(w, "int", name, "0");
	}

	public void dumpMethods(PrintWriter w, boolean intf) {
		dumpMethods(w, "int", name, intf);
		w.println(Bonfire.format("countermethods", name));
	}
	
	public void dumpParseCode(PrintWriter w) {
		w.print(Bonfire.format("inccounter", name));
	}
	
}
