/* Generated By:JJTree: Do not edit this line. Definition.java */
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 160299 KH add *DTD methods after scema *HTML

package bonfire;

import java.io.*;
import java.util.*;
import com.objectspace.jgl.*;

public class Definition extends BNFParserNode {

	public static final int TYPE = 2;

	private String name;
	private int refcnt = 0;
	private BNFParserNode definiens = null;
	private NonTerminal nt = null;
	private SList referrers = new SList();
	private int typenum;
	private boolean neednode = false;
	private int ownattribs = 0;
	private int stype = 0;
	private int itcnt = 1;
	protected StructComment section;

	private DList attributes = new DList();

	/** List of classes this class derives fields from. */
	private Definition superclass = null;
	/** List of classes that derive fields from this class. */
	private SList subclasses = new SList();
	/** True, if an interface is to be written for this class in addition
	 *  to the normal class declaration.
	 */
	boolean makeintf = false;

	private static int numdefs = 1;

	protected static Definition current = null;

	protected static ORList currentORList = null;

	public Definition(int id) {
		super(id);
		typenum = numdefs++;
		section = Bonfire.getCurrSection();
	}
	
	public Definition(BNFParser p, int id) {
		super(p, id);
		typenum = numdefs++;
		section = Bonfire.getCurrSection();
	}

	/** Constructor that creates predefined types such as %STRING, %INTEGER
	 *	%FLOAT and %DATE.
	 *
	 *  @param id Parameter that is passed to SimpleNode
	 *  @param specialtype Number of prefined definition
	 *  @param sname Name of predefined definition
	 *
	 */
 	public Definition(int id, int specialtype, String sname) {
		super(id);
		typenum = numdefs++;
		stype = specialtype;
		name = sname;
		BNFParser.addDefinition(this, name);
		EBNFDefinitions.instance.addDefinition(this);
		switch(specialtype) {
		case NonTerminal.NT_STRING:
			attributes.add(new StringAttribute("String", null));
			break;
		case NonTerminal.NT_INTEGER:
			attributes.add(new IntegerAttribute("Int", null));
			break;
		case NonTerminal.NT_FLOAT:
			attributes.add(new DoubleAttribute("Double", null));
			break;
		case NonTerminal.NT_DATE:
			attributes.add(new DateAttribute("Date", null));
			break;
		default:
			Object arg[] = { new Integer(specialtype) };
			Bonfire.error("wrongtypedef", arg);
			break;
		}
		section = Bonfire.getCurrSection();
	}

	public int getTYPE() {
		return TYPE;
	}

	/** Return current type counter, and increment it. Used for assigning
	 *  unique TYPE constants to every class.
	 *
	 *  return Unique type number
	 */
	public static int getTypeNum() {
		return numdefs++;
	}

	/** Add definition to global list. Called by parser, don't use!
	 */
	public void jjtClose() {
		//name = first_token.image.substring(1, first_token.image.length()-1);
		name = nt.getName();
		nt.setDefinition(this);
		if (BNFParser.getDefinition(name) != null) {
			Object arg[] = { name };
			Bonfire.error("morethanonce", arg);
		}
		BNFParser.addDefinition(this, name);
	}
	
	/** Useless debugging function.
	 *
	 *  @return Useless debugging string
	 */
	public String toString() {
		return "Definition of <"+name+">:";
	}

	/** Another useless debugging funtion
	 *
	 *  @return String that contains name with &lt; and &gt; around it.
	 */
	public String name() {
		return "<"+name+">";
	}

	/** Set the right side of the definition (lat.: <i>definiens</i>).
	 *
	 *  @param n Node that contains the definition
	 */
	public void setDefiniens(Node n) {
		if (n == null) System.out.println("n == null");
		definiens = (BNFParserNode)n;
	}

	/** Set non-terminal that stands on the left side of the definition.
	 *
	 *  @param n NonTerm on left side of definition
	 */
	public void setNT(Node n) {
		nt = (NonTerminal) n;
	}

	/** Return the non-terminal on the left side of the definition of this
	 *  definition.
	 *
	 *  @return NonTerminal that is defined by this definition
	 */
	public NonTerminal getNT() {
		return nt;
	}

	/** Useless debugging function. Useless.
	 *
	 *  @param w PrintWriter to write useless debugging message to.
	 */
	public void dumpASCII(PrintWriter w) {
		if (definiens == null) return;
		w.print("<"+name+"> ::= ");
		definiens.dumpASCII(w);
		w.println();
	}

	/** Make all Non-Terminals look for their definitions.
	 *
	 *  @param user Definition that called the function. Unused here, but used in all the other resolve functions.
	 *
	 *  @see NonTerminal#resolve
	 *  @see BNFParserListNode#resolve
	 *  @see Expr#resolve
	 */
	public void resolve(Definition user, BNFParserNode paren) {
		if (definiens != null) definiens.resolve(this, this);
	}
	
	/** Add a definition that uses this definition, if it is not in the
	 *	list already.
	 *
	 *  @param n Node to add to list of referrers.
	 *  @see Definition#referrers
	 *  @see Definition#refcnt
	 */
	public void addReferrer(BNFParserNode n) {
		if (!referrers.contains(n)) {
			refcnt++;
			referrers.add(n);
		}
	}
	
	/** Add an attribute to list of attributes of this definition.
	 *
	 *  @param a Attribute to add
	 *  @see Definition#attributes
	 */
	public void addAttribute(ClassAttribute a) {
		attributes.add(a);
		ownattribs++;
	}

	/** Return number of referrers.
	 *
	 *  @return Number of definitions that use this one.
	 *  @see Definition#refcnt
	 */
	public int getRefCnt() {
		return refcnt;
	}

	/** Write HTML-part for this definition.
	 *
	 *  @param w PrintWriter to write the HTML to
	 *  @param shortform If true, only write the left side of the definition
	 *  @param langname Name of the language.
	 */
	public void dumpHTML(PrintWriter w, boolean shortform, String langname) {
		current = this;
		if (shortform) {
			Object args[] = { langname,
							  name,
							  (definiens==null)?"%":"" };
			w.println(Bonfire.format("shorthtmlentry", args));
			return;
		}
		Object args[] = { name,
						  Bonfire.getPackage(),
						  translateNonTerm(name),
						  Bonfire.getHTMLJavaDocDir() };
		w.print(Bonfire.format("defanchor", args));
		if (definiens == null)
			if (Bonfire.getMakeClasses())
				w.println(Bonfire.format("predefined", args));
			else w.println(Bonfire.format("predef-nolink", args));
		else {
			dumpHTMLComments(w);
			if (Bonfire.getMakeClasses())
				w.println(Bonfire.format("defhtmlbegin", args));
			else w.println(Bonfire.format("defhtmlbeg-nolink", args));
			definiens.dumpHTML(w);
			w.println(Bonfire.format("defhtmlend"));
		}
	}

	/** Write DTD-part for this definition.
	 *
	 *  @param w PrintWriter to write the DTD to
	 *  @param shortform If true, only write the left side of the definition
	 *  @param langname Name of the language.
	 */
	public void dumpDTD(PrintWriter w, boolean shortform, String langname) {
		current = this;
		Object args[] = { name,
						  Bonfire.getPackage(),
						  translateNonTerm(name),
						  Bonfire.getDTDDir() };
		if (definiens == null) {
			if (Bonfire.getMakeClasses())
				w.print(Bonfire.format("predefineddtd", args));
			else w.print(Bonfire.format("predefdtd-nolink", args));
//      dumpDTDRef(w);
      }
		else {   
//			dumpHTMLComments(w);
			if (Bonfire.getMakeClasses())
				w.print(Bonfire.format("defdtdbegin", args));
			else w.print(Bonfire.format("defdtdbeg-nolink", args));
      w.print(" (");
			definiens.dumpDTD(w);
      w.print(")* ");
//      dumpDTDRef(w);
			w.print(Bonfire.format("defdtdend"));
		}
	}

	/** Write Cross-Ref entry for this definition.
	 *
	 *  @param w PrintWriter to write the entry to.
	 */
	public void dumpXRef(PrintWriter w) {
		Object args[] = { name,
						  (definiens==null)?"%":"" };
		w.println(Bonfire.format("xrefdef", args));
		if (referrers.size() > 0) {
			w.println(Bonfire.format("usedin"));
			SListIterator it=referrers.begin();
			while (!it.atEnd()) {
				((Definition)it.get()).getNT().dumpXREF(w);
				it.advance();
				if (!it.atEnd()) w.print(", ");
			}
			w.println(Bonfire.format("xrefend"));
		} else w.println(Bonfire.format("neverused"));
	}

	/** Write Cross-Ref entry DTD ATTRIBUT definition.
	 *
	 *  @param w PrintWriter to write the entry to.
	 */
	public void dumpDTDRef(PrintWriter w) {
		Object args[] = { name,
						  (definiens==null)?"%":"" };
		w.print(Bonfire.format("dtdrefdef", args));
		if (referrers.size() > 0) {
			w.print(Bonfire.format("dtdref"));
			SListIterator it=referrers.begin();
			while (!it.atEnd()) {
				((Definition)it.get()).getNT().dumpDTDREF(w);
				it.advance();
				if (!it.atEnd()) w.print(", ");
			}
			w.print(Bonfire.format("dtdrefend", args));
		}
	}

	/** Check to see if we need to create an interface. This function used
	 *  to do more, but has suffered from redesign.
	 *
	 *  @see Definition#setMakeIntf
	 */
	public void deriveClasses() {
		for (DListIterator it = attributes.begin(); !it.atEnd(); it.advance())
			if ((it.get() instanceof PointerAttribute) ||
				(it.get() instanceof ListAttribute))
				((ClassAttribute)it.get()).findSuperClass();
		//	definiens.generateAttributes(this, true);
		//if (superclasses.size() > 1) {
		//	setMakeIntf();
		//}
	}

	/** Set makeintf of this definition and all definitions it inherits from.
	 *
	 *  @see Definition#makeintf
	 */
	public void setMakeIntf() {
		makeintf = true;
		//for (SListIterator it=superclasses.begin(); !it.atEnd(); it.advance())
		//	((Definition)it.get()).setMakeIntf();
		if (superclass != null) superclass.setMakeIntf();
	}

	/** Add a definition as one that this definition inherits from.
	 *
	 *  @param d Defininition to add
	 *  @see Definition#superclasses
	 */
	public void setSuperclass(Definition d) {
		//if (!superclasses.contains(d))
		//	superclasses.add(d);
		superclass = d;
	}

	public Definition getSuperclass() {
		return superclass;
	}

	/** Add a definition as one that inherits from this definition. 
	 *
	 *  @param d Definition to add
	 *  @see Definition#subclasses
	 */
	public void addSubclass(Definition d) {
		if (!subclasses.contains(d))
			subclasses.add(d);
	}
	
	/** Return the number of classes/definition this definition inherits from.
	 *
	 *  @return number of superclasses
	 */
	public int numSuperclasses() {
		//return superclasses.size();
		return 1;
	}
	
	/** Propagate all own and inherited attributes to all the subclasses.
	 *  Attributes that will be inherited "naturally" by means of the Java
	 *  mechanisms are discarded afterwards.
	 *
	 */
	/*	public void mergeAttributes() {
		//if (superclasses.size() == 0)
		//	appendDList(attributes, getAttributeIntersection());
		DList attrlist2 = new DList();
		boolean list2 = (superclasses.size() <= 1);
		for (SListIterator it=superclasses.begin(); !it.atEnd(); it.advance()) {
			
			DListIterator ait = ((Definition)it.get()).getFirstAttribIt();
			while (!ait.atEnd()) {
				ClassAttribute attr = (ClassAttribute)ait.get();
				if ((!attr.getIntersection()) && (!attributes.contains(attr))) {
					attributes.add(attr);
					if (list2) attrlist2.add(attr);
				}
				ait.advance();
			}
		}
		for (SListIterator it=subclasses.begin(); !it.atEnd(); it.advance())
			((Definition)it.get()).mergeAttributes();
		for (DListIterator it=attrlist2.begin(); !it.atEnd(); it.advance())
			attributes.remove(it.get());
			}*/

	/** Return an iterator positioned on the first attribute of this
	 *  definition.
	 *
	 *  @return Iterator pointing to first attribute
	 */
	public DListIterator getFirstAttribIt() {
		return attributes.begin();
	}

	public void replaceAttribute(ClassAttribute old, ClassAttribute nouveau) {
		attributes.replace(old, nouveau);
	}

	/** Return intersection of all subclasses' attributes.
	 *
	 *  @return List containing intersection of all subclasses' attributes
	 */
	public DList getAttributeIntersection() {
		DList res = new DList();
		if (subclasses.size() == 0) return new DList(attributes);
		else if (subclasses.size() == 1) {
			Definition def = (Definition)subclasses.begin().get();
			return def.getAttributeIntersection();
		}
		DList sublists = new DList();
		for (SListIterator it=subclasses.begin(); !it.atEnd(); it.advance()) {
			DList l = ((Definition)it.get()).getAttributeIntersection();
			sublists.add(l);
		}
		for (DListIterator sit=sublists.begin(); !sit.atEnd(); sit.advance()) {
			DList currlist = (DList)sit.get();
			for (DListIterator lit=currlist.begin(); !lit.atEnd(); ) {
				ClassAttribute currattr = (ClassAttribute)lit.get();
				boolean keep = true;
				DList equallist = new DList();
				DList listlist = new DList();
				DListIterator sit2 = (DListIterator)sit.clone();
				sit2.advance();				
				while ((keep) && (!sit2.atEnd())) {
					DListIterator ccit = ((DList)sit2.get()).begin();
					boolean found = false;
					while ((!found) && (!ccit.atEnd())) {
						ClassAttribute attr = (ClassAttribute)ccit.get();
						found = attr.equals(currattr);
						if (found) {
							equallist.add(attr);
							listlist.add(sit2.get());
						}
						ccit.advance();
					}
					keep = found;
					sit2.advance();
				}
				if (keep) {
					currattr.setIntersection(true);
					res.add(currattr);
					DListIterator eqit = equallist.begin();
					for ( ; !eqit.atEnd(); eqit.advance()) {
						ClassAttribute a = (ClassAttribute)eqit.get();
						Definition def = (Definition)a.getOwner();
						def.replaceAttribute(a, currattr);
					}
					eqit = equallist.begin();
					for (DListIterator llit=listlist.begin(); !llit.atEnd();) {
						((DList)llit.get()).remove(eqit.get());
						llit.advance();
						eqit.advance();
					}					
				}
				lit.advance();
			}
		}
		return res;
	}

	/** Write class and (if necessary) interface to file.
	 *
	 *  @see Definition#makeintf
	 */
	public void dumpClasses() {
		writeClass(false);
		if (makeintf) writeClass(true);
	}

	/** Write a class or interface for this definition to a file. 
	 *
	 *  @param intf If true, write the interface, otherwise write the class
	 */
	public void writeClass(boolean intf) {
		current = this;
		String cname = name;
		if (intf) cname = getIntfName();
		cname = translateNonTerm(cname);
		String ln = translateNonTerm(Bonfire.getLangName());
		Object wargs[] = { Bonfire.getClassDir()+cname+".java",
						   new Integer(attributes.size()) };
		Bonfire.out("writeclass", wargs);
		PrintWriter w = Bonfire.openFile(Bonfire.getClassDir()+cname+".java");
		w.println(Bonfire.format("classcomment", (new Date()).toString()));
		if (Bonfire.getPackage() != null) {
			w.println(Bonfire.format("package", Bonfire.getPackage()));
			w.println();
		}
		w.println(Bonfire.format("classfileheader"));
		Object declargs[] = { (stype != 0)?"%"+name:name,
							ln,
							cname };
		if (intf)  { 
			w.print(Bonfire.format("intfdecl", declargs));
			//if (superclasses.size() >= 1) w.print(Bonfire.format("extends"));
			if (superclass != null) w.print(Bonfire.format("extends"));
		} else {
			w.print(Bonfire.format("classdecl", declargs));
			//if (superclasses.size() != 1) w.print(ln+"ParserNode ");
			//else // superclasses.size() == 1
				//w.print(translateNonTerm(((Definition)superclasses.begin().get()).getName())+" ");
				if (superclass != null) w.print(translateNonTerm(superclass.getName())+" ");
				else w.print(ln+"ParserNode ");
			if (makeintf) w.print("implements ");
		}
		if (makeintf) {
			if (!intf) {
				w.print(translateNonTerm(getIntfName()));
				//if (superclasses.size() >= 1) w.print(", ");
			}
			/*for (SListIterator it=superclasses.begin(); !it.atEnd(); ) {
				w.print(translateNonTerm(((Definition)it.get()).getIntfName()));
				it.advance();
				if (!it.atEnd()) w.print(", ");
				}*/
		}
		w.println(Bonfire.format("typedecl", new Integer(typenum).toString()));
		if (!intf) {
			w.println();
			w.println(Bonfire.format("hookdecl"));
			w.println();
			for (DListIterator it=attributes.begin(); !it.atEnd(); it.advance()) {
				((ClassAttribute)it.get()).dumpDeclaration(w);
				w.println();
			}
			w.println();
			w.println(Bonfire.format("constructor", cname));
			w.println();
		}
		w.print(Bonfire.format("gettype"));
		if (!intf) w.println(Bonfire.format("gettypebody"));
		else w.println(";");
		w.println();
		w.print(Bonfire.format("sethd"));
		if (!intf) w.println(Bonfire.format("sethdbody"));
	    else w.println(";");
		w.println();
		w.print(Bonfire.format("gethd"));
		if (!intf) w.println(Bonfire.format("gethdbody"));
		else w.println(";");
		w.println();
		if ((definiens == null) && (!intf)) {
			w.println(Bonfire.format("jjtclose"));
			switch(stype) {
			case NonTerminal.NT_STRING:
				w.println(Bonfire.format("jjtcstring"));
				break;
			case NonTerminal.NT_INTEGER:
				w.println(Bonfire.format("jjtcint"));
				break;
			case NonTerminal.NT_FLOAT:
				w.println(Bonfire.format("jjtcdouble"));
				break;
			case NonTerminal.NT_DATE:
				w.println(Bonfire.format("jjtcdate"));
				break;
			}		
			w.println(Bonfire.format("jjtcend"));
			w.println();
		}
		if (definiens != null) {
			if (!(definiens instanceof NonTerminal)) {
				w.println(Bonfire.format("toStringhead"));
				definiens.maketoString(w, 0);
				w.println(Bonfire.format("toStringend"));
			}
		} else {
			w.println(Bonfire.format("toStringheadpredef"));
			switch(stype) {
			case NonTerminal.NT_STRING:
				w.println(Bonfire.format("deftsstring"));
				break;
			case NonTerminal.NT_INTEGER:
				w.println(Bonfire.format("deftsint"));
				break;
			case NonTerminal.NT_FLOAT:
				w.println(Bonfire.format("deftsdouble"));
				break;
			case NonTerminal.NT_DATE:
				w.println(Bonfire.format("deftsdate"));
				break;				
			}
		}
		for (DListIterator it=attributes.begin(); !it.atEnd(); it.advance()) {
			((ClassAttribute)it.get()).dumpMethods(w, intf);
			w.println();
		}
		w.println("}");
		w.close();
	}

	/** Generate attributes for this Definition. This method also takes care
	 *  of finding derived classes, it's much easier this way.
	 *
	 *  @param def Definition that called this method. Unused here, but used in the other nodes
	 *  @param toplevel If true, this construct is the root node of a definition. Unused here.
	 */
	public DList generateAttributes(Definition def, boolean toplevel) {
		current = this;
		currentORList = null;
		ORList.setCurrent(null);
		if (definiens instanceof NonTerminal) {
			NonTerminal nt = (NonTerminal)definiens;
			Definition d = nt.getDefinition();
			if (d == null) {
				Object arg[] = { nt.getName() };
				Bonfire.error("notdefined", arg);
			}
			setSuperclass(d);
			d.addSubclass(this);
			nt.setAttribute(new PassthroughAttribute("", nt));
			setNeedNode(true);
		} else if (definiens != null)
			appendDList(attributes, definiens.generateAttributes(this, 0, true));
		return attributes;
	}
	
	/** Write parser part of this definition.
	 *
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpParser(PrintWriter w) {
		if (definiens == null) {
			switch(stype) {
			case NonTerminal.NT_STRING:
				w.println("Node STRING() : { }");
				w.println("{");
				w.println("\t  <STRING> { return jjtThis; }");
				w.println("}");
				w.println();
				break;
			case NonTerminal.NT_INTEGER:
				w.println("Node INTEGER() : { }");
				w.println("{");
				w.println("\t  <INTEGER> { return jjtThis; }");
				w.println("}");
				w.println();
				break;
			case NonTerminal.NT_FLOAT:
				w.println("Node FLOAT() : { }");
				w.println("{");
				w.println("\t  <FLOAT> { return jjtThis; }");
				w.println("}");
				w.println();
				break;
			case NonTerminal.NT_DATE:
				w.println("Node DATE() : { }");
				w.println("{");
				w.println("\t  <DATE> { return jjtThis; }");
				w.println("}");
				w.println();
				break;
			}
		} else {
			w.println("Node "+translateNonTerm(name)+"() : {");
			if (neednode) { 
				w.println();
				w.println("\tNode n = null;");
				w.println("}");
			} else w.println("}");
			w.println("{ (");
			w.print("\t  ");
			definiens.dumpParser(w);
			/*if (ownattribs == 0)*/ w.println("\t) {return jjtThis;}");
			w.println("\n}\n");
		}
	}

	/** Change the names in the list of attributes so that they become unique.
	 *  This method needs to be called until it returns false, otherwise
	 *  there might still be collisions due to the fact that only pointers
	 *  are stored in the lists, and these are used in more than one
	 *  definition.
	 *
	 *  return True, if names had to be changed
	 */
	public boolean uniqueAttributes() {
		boolean res = false;
		for (DListIterator it=attributes.begin(); !it.atEnd(); it.advance()) {
			ClassAttribute a = (ClassAttribute)it.get();
			String currname = a.getName();
			int cnt = 2;
			DListIterator itt = (DListIterator)it.clone();
			itt.advance();
			while (!itt.atEnd()) {
				ClassAttribute aa = (ClassAttribute)itt.get();
				if (currname.equals(aa.getName())) {
					String cname = currname;
					int rg = currname.lastIndexOf("_");
					if ((rg > -1) && (rg != currname.length()-1)) {
						boolean allnums = true;
						for (int i = rg+1; i < currname.length(); i++)
							allnums &= Character.isDigit(currname.charAt(i));
						if (allnums) {
							cnt = Integer.decode(currname.substring(rg+1)).intValue()+1;
							cname = currname.substring(0, rg);
						}
					}
					aa.setName(cname+"_"+cnt);
					cnt++;
					res = true;
				}
				itt.advance();
			}
		}
		return res;
	}
	
	/** Return the name of the non-terminal defined by this definition.
	 *  Name does not contain the brackets.
	 *
	 *  @return Name of the non-terminal defined by this definition
	 */
	public String getName() {
		return name;
	}

	/** Return name of the interface associated with this class/definition.
	 *
	 *  @return Name of this definiton's interface
	 */
	public String getIntfName() {
		return name+"_Intf";
	}

	/** Set the neednode member variable. If neednode is true, a variable
	 *  n of type Node is declared for this parser production. That variable
	 *  is needed by ListAttribute, PointerAttributes and
	 *  PassthroughAttributes.
	 *
	 *  @param n Value to set neednode to
	 *  @see Definition#neednode
	 *  @see ListAttribute
	 *  @see PassthroughAttribute
	 *  @see PointerAttribute
	 */
	public void setNeedNode(boolean n) {
		neednode = n;
	}

	/** Return section object that was the current one when this definition
	 *  was parsed.
	 *
	 *  @return section object this definition "belongs" to
	 */
	public StructComment getCurrSection() {
		return section;
	}

	public int getItCnt() {
		return itcnt;
	}

	public void setItCnt(int c) {
		itcnt = c;
	}

	public static Definition getCurrent() {
		return current;
	}

	public static ORList getCurrentORList() {
		return currentORList;
	}

	public static void setCurrentORList(ORList l) {
		currentORList = l;
	}
	
}
