/* Generated By:JJTree: Do not edit this line. EBNFDefinitions.java */
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 160299 KH add *DTD methods after scema *HTML


package bonfire;

import java.io.*;
import java.util.*;
import com.objectspace.jgl.*;
import com.objectspace.jgl.algorithms.*;

/** Bonfire's main list of Definitions. This class creates all kinds of files.
 *  There usually only is one instance of this class.
 *
 *  @see Definition
 */
public class EBNFDefinitions extends BNFParserNode {

	private class StringCompare implements BinaryPredicate {
		public boolean execute(Object first, Object second) {
			return (((Definition)first).getName().compareTo(((Definition)second).getName()) <= 0);
		}
	}

	public static final int TYPE = 3;

	private SList defs = new SList();;
	private int numroots = 0;
	private SList roots = new SList();
	public static EBNFDefinitions instance = null;

	public EBNFDefinitions(int id) {
		super(id);
		instance = this;
	}
	
	public EBNFDefinitions(BNFParser p, int id) {
		super(p, id);
		instance = this;
	}

	/** Return the TYPE constant. This is necessary because accessing the
	 *  TYPE constant via a pointer to a superclass returns the wrong value.
	 *  @see EBNFDefinitions#TYPE
	 */
	public int getTYPE() {
		return TYPE;
	}

	/** Add a new definition to the list.
	 *
	 *  @param d Definition to be added
	 */
	public void addDefinition(Definition d) {
		defs.add(d);
	}
	
	/** Dump all the definitions to an ASCII file. Only used for debugging.
	 *
	 *  @param w PrintWriter object to write to
	 */
	public void dumpASCII(PrintWriter w) {
		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
			((Definition)it.get()).dumpASCII(w);
	}
	
	/** Find the definition for every non-terminal. After this method has
	 *  been called, the real work can begin..
	 */
	public void resolve() {
		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
			((Definition)it.get()).resolve(null, null);
	}

	/** Write HTML documentation. This method creates four files:
	 *  <ul>
	 *  <li> <b>index.html</b>. The file that contains the definition of
	 *    the framesets.
	 *  <li> <b><i>languagename</i>Struct.html</b>. The crude structure of
	 *    the language, based on //@section-comments.
	 *  <li> <b><i>languagename</i>Links.html</b>. A list of all the
	 *    non-terminals, structured by section headings.
	 *  <li> <b><i>languagename</i>BNF.html</b>. All definitions plus comments,
	 *    structured by section headings, and a cross-ref section.
	 *  </ul>
	 *
	 *  @param name Name of the language being processed
	 */
	public void dumpHTML(String name) {
		// index.html
		Bonfire.out("writing", Bonfire.getHTMLDir()+"index.html");
		PrintWriter w = Bonfire.openFile(Bonfire.getHTMLDir()+"index.html");
		Object args[] = { Bonfire.getLangName(),
						  name };
		w.println(Bonfire.format("index.html", args));
		w.close();
		// <LangName>Struct.html
		Bonfire.out("writing", Bonfire.getHTMLDir()+name+"Struct.html");
		w = Bonfire.openFile(Bonfire.getHTMLDir()+name+"Struct.html");
		w.println(Bonfire.format("structhead", Bonfire.getLangName()));
		if (Bonfire.getFirstSection() != null) {
			w.println(Bonfire.format("structliststart"));
			Bonfire.getFirstSection().dumpHeader(w, name+"Links.html");
			w.println(Bonfire.format("structlistend"));
		}
		w.println(Bonfire.format("htmlend"));
		w.close();
		// <LangName>Links.html
		Bonfire.out("writing", Bonfire.getHTMLDir()+name+"Links.html");
		w = Bonfire.openFile(Bonfire.getHTMLDir()+name+"Links.html");
		w.println(Bonfire.format("linkhead", name));
		SListIterator it=defs.begin();
		StructComment sec = ((Definition)it.get()).getCurrSection();
		if (sec != null) {
			if (sec != Bonfire.getFirstSection()) Bonfire.getFirstSection().dumpHTML(w, true, name+"BNF.html");
			sec.dumpHTML(w, true, name+"BNF.html");
		}
		for ( ; !it.atEnd(); it.advance()) {
			Definition def = (Definition)it.get();
			if (sec != def.getCurrSection()) {
				sec = def.getCurrSection();
				sec.dumpHTML(w, true, name+"BNF.html");
			}
			def.dumpHTML(w, true, name);
		}
		w.println(Bonfire.format("htmlend"));
		w.close();
		// <LangName>BNF.html
		Bonfire.out("writing", Bonfire.getHTMLDir()+name+"BNF.html");
		w = Bonfire.openFile(Bonfire.getHTMLDir()+name+"BNF.html");
		Object bnfargs[] = { Bonfire.getLangName(),
							 (new Date()).toString(),
							 new Integer(BNFParser.getNumDefs()),
							 new Integer(BNFParser.getNumTerminals()),
							 Bonfire.getRoot().getName() };
		w.println(Bonfire.format("bnfhead", bnfargs));
		if (numroots > 1) {
			w.println(Bonfire.format("otherroots"));
			it = roots.begin();
			it.advance();
			for (; !it.atEnd(); ) {
				String rname = ((Definition)it.get()).getName();
				w.print(Bonfire.format("rootlist", rname));
				it.advance();
				if (!it.atEnd()) w.print(", ");
				else w.print(".");
			}
		}
		w.println(Bonfire.format("bnfdefs"));
		it=defs.begin();
		sec = ((Definition)it.get()).getCurrSection();
		if (sec != null) {
			if (sec != Bonfire.getFirstSection()) Bonfire.getFirstSection().dumpHTML(w, false, "");
			sec.dumpHTML(w, false, "");
		}
		for ( ; !it.atEnd(); it.advance()) {
			Definition def = (Definition)it.get();
			if (sec != def.getCurrSection()) {
				sec = def.getCurrSection();
				sec.dumpHTML(w, false, "");
			}
			def.dumpHTML(w, false, name);
		}
		w.println(Bonfire.format("xrefhead"));
		Range r = Sorting.iterSort(defs, new StringCompare());
		for (ForwardIterator fit=r.begin; !fit.atEnd(); fit.advance())
			((Definition)fit.get()).dumpXRef(w);
		w.println(Bonfire.format("xrefsecend"));
		w.println(Bonfire.format("noteshead"));
		NoteorQuestion.dumpNotesList(w);
		w.println(Bonfire.format("notesend"));
		w.println(Bonfire.format("questionshead"));
		NoteorQuestion.dumpQuestionsList(w);
		w.println(Bonfire.format("questionsend"));
		w.println(Bonfire.format("htmlend"));
		w.close();
	}

	/** Write XML-DTD file:
	 *  <b><i>languagename</i>BNF.dtd</b>. All definitions without comments.
	 *
	 *  @param name Name of the language being processed
	 */
	public void dumpDTD(String name) {
		// <LangName>BNF.dtd
		Bonfire.out("writing", Bonfire.getDTDDir()+name+"BNF.DTD");
		PrintWriter w = Bonfire.openFile(Bonfire.getDTDDir()+name+"BNF.DTD");
		SListIterator it=defs.begin();
		StructComment sec = ((Definition)it.get()).getCurrSection();
		Object bnfargs[] = { name+"BNF",
							 (new Date()).toString(),
							 new Integer(BNFParser.getNumDefs()),
							 new Integer(BNFParser.getNumTerminals()),
							 Bonfire.getRoot().getName() };
		w.println(Bonfire.format("dtdhead", bnfargs));
		it=defs.begin();
		sec = ((Definition)it.get()).getCurrSection();
		if (sec != null) {
			if (sec != Bonfire.getFirstSection()) Bonfire.getFirstSection().dumpDTD(w, false, "");
			sec.dumpDTD(w, false, "");
		}
		for ( ; !it.atEnd(); it.advance()) {
			Definition def = (Definition)it.get();
			if (sec != def.getCurrSection()) {
				sec = def.getCurrSection();
				sec.dumpDTD(w, false, "");
			}
			def.dumpDTD(w, false, name);
		}
		w.println(Bonfire.format("dtdend"));
		w.close();
	}

	/** Find the first non-terminal that is used by no other non-terminal.
	 *	That's the starting non-terminal for the parser.
	 *
	 *  @return The definition object of the starting non-terminal
	 */
	public Definition findRoot() {
		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
			if (((Definition)it.get()).getRefCnt() == 0)
				return (Definition) it.get();
		return null;
	}
	
	/** Count the number of possible roots.
	 *
	 *  @see EBNFDefinitions#findRoot()
	 *  @return number of possible roots
	 */
	public int countRoots() {
		if (numroots > 0) return numroots;
		else {
			int num = 0;
			for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
				if (((Definition)it.get()).getRefCnt() == 0) {
					num++;
					roots.add(it.get());
				}
			numroots = num;
			return num;
		}
	}

	/** Return an iterator to the first possible root.
	 *
	 *  @return iterator to the first possible root.	 
	 */
	public SListIterator getFirstRootIt() {
		return roots.begin();
	}
	
	/** Derive the class hierarchy. This function triggers the generation of
	 *  attributes, the generation of class-subclass relations, and the
	 *  "unique-ing" of the generated attributes.
	 *
	 *  @see Definition#generateAttributes(Definition, boolean)
	 *  @see Definition#mergeAttributes()
	 *  @see Definition#deriveClasses()
	 *  @see Definition#uniqueAttributes()
	 */
	public void deriveClasses() {
		for (SListIterator it=defs.begin(); !it.atEnd(); ) {
			Definition def = (Definition)it.get();
			Bonfire.outs("<"+def.getName()+">");
			def.generateAttributes(def, true);
			it.advance();
			if (!it.atEnd()) Bonfire.outs(", ");
		}
		Bonfire.outs("\n");
		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
			((Definition)it.get()).deriveClasses();
		//		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance()) {
		//			Definition def = (Definition)it.get();
		//			if (def.numSuperclasses() == 0)
		//				def.mergeAttributes();
		//		}			
		boolean goon;
		do {
			goon = false;
			for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
				goon |= ((Definition)it.get()).uniqueAttributes();
		} while(goon);
	}
	
	/** Writes <tt><i>languagename</i>ParserNode.java</tt> and calls the dumpClasses()
	 *  method for every definition.
	 *
	 *  @param langname Name of the language
	 *  @see Definition#dumpClasses()
	 */
	public void dumpClasses(String langname) {
		PrintWriter w = Bonfire.openFile(Bonfire.getClassDir()+translateNonTerm(Bonfire.getLangName())+"ParserNode.java");
		w.println(Bonfire.format("namecomment", langname));
		w.println(Bonfire.format("classcomment", (new Date()).toString()));
		if (Bonfire.getPackage() != null) {
			w.println(Bonfire.format("package", Bonfire.getPackage()));
		}
		w.println(Bonfire.format("langparsernode", langname));
		w.close();
		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
			//if (((Definition)it.get()).numParents() == 0)
			((Definition)it.get()).dumpClasses();
	}
	
	/** Writes the parser to a file.
	 * 
	 *  @see Definition#dumpParser
	 *  @param langname Name of the language
	 *  @param fname Basename of the file to write to (usually the same as langname)
	 *  @param rootname Name of the production to start parsing at
	 */
	public void dumpParser(String langname, String fname, String rootname) {
		PrintWriter w = Bonfire.openFile(Bonfire.getClassDir()+langname+"Parser.jjt");
		w.println("// Parser for language "+langname);
		w.println(Bonfire.format("classcomment", (new Date()).toString()));
		w.println(Bonfire.format("parserbegin", langname));
		if (Bonfire.getPackage() != null) {
			w.println(Bonfire.format("package", Bonfire.getPackage()));
			w.println();
		}
		Object nameroot[] = { langname, rootname };
		w.println(Bonfire.format("parsermain", nameroot));
		for (SListIterator it=BNFParser.getTerminalsIt(); !it.atEnd(); it.advance()) {
			String termname = (String)it.get();
			w.print("\t");
			if (!it.atBegin()) w.print("|");
			w.println("  <"+BNFParserNode.translateTerm(termname)+": \""+termname+"\">");
		}
		w.println(Bonfire.format("parsertokens"));
		for (SListIterator it=defs.begin(); !it.atEnd(); it.advance())
			((Definition)it.get()).dumpParser(w);
		w.close();
	}

}
