/* Generated By:JJTree: Do not edit this line. Expr.java */
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 170299 KH add *DTD methods after scema *HTML

package bonfire;

import java.io.*;
import com.objectspace.jgl.*;

/** Class that contains a subexpression that is optional or repeated zero or
 *  more or one or more times.
 *
 *  @see ANDList
 *  @see ORList
 */
public class Expr extends BNFParserNode {

	public static final int TYPE = 4;

	/** Type of this expression, as opposed to the type of this object (TYPE).
	 */
	private int type;
	/** Subexpression contained in this expression. */
	private BNFParserNode child;
	/** Token separating any two non-terminals in a "&lt;a&gt; || t" construct. Not
	 *	supported at the moment.
	 */
	private Token or2tok;

	/** Subexpression is optional. */
	public final static int OPTIONAL = 1;
	/** Subexpression is to be repeated zero or more times. */
	public final static int ZEROORMORE = 2;
	/** Subexpression is to be repeated one or more times. */
	public final static int ONEORMORE = 3;
	/** Not used at the moment. &lt;a&gt || t */
	public final static int OR2 = 4;

	public Expr(int id) {
		super(id);
		child = null;
		or2tok = null;
	}
	
	public Expr(BNFParser p, int id) {
		super(p, id);
		child = null;
		or2tok = null;
	}

	public int getTYPE() {
		return TYPE;
	}
	
	/** Debugging function. Please ignore.
	 */
	public String toString() {
		switch(type) {
		case OPTIONAL: return "Expression: Optional"; //break;
		case ZEROORMORE: return "Expression: ZeroOrMore"; //break;
		case ONEORMORE: return "Expression: OneOrMore"; //break;
		case OR2: return "Expression: || "+or2tok.image; //break;
		}
		return "";
	}
	
	/** Set type of this expression.
	 *
	 *  @param t Type value to set
	 *  @see Expr#type
	 */
	public void setType(int t) {
		type = t;
	}

	/** Return type of this expression.
	 *
	 *  @return Type value
	 */
	public int getType() {
		return type;
	}
	
	/** Set the expression contained in this construct
	 *
	 *  @param n Node to set as contained expression
	 */
	public void setChild(Node n) {
		child = (BNFParserNode)n;
	}
	
	/** Set token in "&lt;a&gt || t" construct. Unused.
	 *
	 *  @param t Token to set as separator
	 */
	public void setOr2Tok(Token t) {
		or2tok = t;
	}
	
	/** Useless debugging function. Please ignore.
	 *
	 *  @param w PrintWriter to write useless debugging message to
	 */
	public void dumpASCII(PrintWriter w) {
		switch(type) {
		case OPTIONAL: w.print("[ "); child.dumpASCII(w); w.print(" ]");
			break;
		case ZEROORMORE: w.print("( "); child.dumpASCII(w); w.print(" )*");
			break;
		case ONEORMORE: w.print("( "); child.dumpASCII(w); w.print(" )+");
			break;
		case OR2: child.dumpASCII(w); w.print(" || "+or2tok.image);
			break;
		}
	}
	
	/** Find definitions for all non-terminals. This call is just passed on
	 *  to the subexpression.
	 *
	 *  @param user Definition that started this call sequence
	 */
	public void resolve(Definition user, BNFParserNode paren) {
		parent = paren;
		child.resolve(user, this);
	}
	
	/** Write HTML part for this fragment.
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpHTML(PrintWriter w) {
		dumpHTMLNewLines(w);
		switch(type) {
		case OPTIONAL: w.print("[ "); child.dumpHTML(w); w.print(" ]");
			break;
		case ZEROORMORE: w.print("( "); child.dumpHTML(w); w.print(" )*");
			break;
		case ONEORMORE: 
			if ((child instanceof NonTerminal) || (child instanceof Terminal)) {
				child.dumpHTML(w); w.print("+");
			} else {
				w.print("( "); child.dumpHTML(w); w.print(" )+");
			}
			break;
		case OR2: child.dumpHTML(w); w.print(" || "+or2tok.image);
			break;
		}
	}

	/** Write DTD part for this fragment.
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpDTD(PrintWriter w) {
//		dumpHTMLNewLines(w);
//    w.print("\n");
		switch(type) {
		case OPTIONAL: w.print("[ "); child.dumpDTD(w); w.print(" ]");
			break;
		case ZEROORMORE: w.print("( "); child.dumpDTD(w); w.print(" )*");
			break;
		case ONEORMORE: 
			if ((child instanceof NonTerminal) || (child instanceof Terminal)) {
				child.dumpDTD(w); w.print("+ ");
			} else {
				w.print("( "); child.dumpDTD(w); w.print(" )+");
			}
			break;
		case OR2: child.dumpDTD(w); w.print(" || "+or2tok.image);
			break;
		}
	}

	/** Make subexpression generate attributes, passing an altered env
	 *	parameter on.
	 *
	 *  @param def Definition this Expr belongs to
	 *  @param env Description of the "history" of this call in terms of the constants defined in BNFParserNode
	 *  @param toplevel True, if this fragment is on the first level of a definition's tree.
	 *  @return List of generated attributes
	 *  @see BNFParserNode#OPTIONAL_F
	 *  @see BNFParserNode#ONEORMORE_F
	 *  @see BNFParserNode#ZEROORMORE_F
	 *  @see BNFParserNode#OR_F
	 */
	public DList generateAttributes(Definition def, int env, boolean toplevel) {
		switch(type) {
		case OPTIONAL:
			return child.generateAttributes(def, env | OPTIONAL_F, false);
		case ZEROORMORE:
			return child.generateAttributes(def, env | ZEROORMORE_F, false);
		case ONEORMORE:
			return child.generateAttributes(def, env | ONEORMORE_F, false);
		case OR2: Bonfire.error("unhandled", "");
			break;
		}			
		return null; // make compiler happy
	}
	
	/** Write parser part of this fragment.
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpParser(PrintWriter w) {
		switch(type) {
		case OPTIONAL: w.print("[ "); child.dumpParser(w); w.print(" ]");
			break;
		case ZEROORMORE: w.print("( "); child.dumpParser(w); w.print(" )*");
			break;
		case ONEORMORE: w.print("( "); child.dumpParser(w); w.print(" )+");
			break;
		case OR2: child.dumpParser(w); w.print(" || \""+or2tok.image+"\"");
			break;
		}
	}

	public void maketoString(PrintWriter w, int env) {
		switch(type) {
		case OPTIONAL: 
			if ((env & (ZEROORMORE_F | ONEORMORE_F)) != 0)
				Bonfire.error("unsupported", Bonfire.bformat("optinrepeat", Definition.getCurrent().getName()));
			child.maketoString(w, env | OPTIONAL_F);
			break;
		case ZEROORMORE:
		case ONEORMORE:
			if (child instanceof ANDList) {
				String firstit = ((ANDList)child).declareIts(w);
				w.println(Bonfire.format("exprtsbeg", firstit));
				child.maketoString(w, env | ZEROORMORE_F);
				w.println(Bonfire.format("exprtsend"));
			} else if (type == ZEROORMORE)
				child.maketoString(w, env | ZEROORMORE_F);
			else child.maketoString(w, env | ONEORMORE_F);
			break;
			//		case OR2: 
			//			break;
		}
	}

}
