// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara

package bonfire;

import java.io.*;

class ListAttribute extends ClassAttribute {

	public final static int TYPE = -4;

	ListAttribute(String n, BNFParserNode o) {
		super(n, o);
		typ = n;
	}

	public int getTYPE() {
		return TYPE;
	}

	//	public String getName() {
	//		return "_"+name+"list";
	//	}
	
	public void dumpDeclaration(PrintWriter w) {
		w.println(Bonfire.format("listdecl", name));
		dumpListenerDeclaration(w, name, "null");
	}

	public void dumpMethods(PrintWriter w, boolean intf) {
		Object nametyp[] = { name, typ };
		w.print(Bonfire.format("listadd", nametyp));
		if (intf) w.println(";");
		else w.println(Bonfire.format("listaddbody", name));
		w.println();
		w.print(Bonfire.format("listrem", nametyp));
		if (intf) w.println(";");
		else w.println(Bonfire.format("listrembody", name));
		w.println();
		w.print(Bonfire.format("listgetfirst", name));
		if (intf) w.println(";");
		else w.println(Bonfire.format("listgetfirstbody", name));
		dumpListenerMethods(w, name, intf);
	}

	public void dumpParseCode(PrintWriter w) {
		Object arg[] = { name, typ };
		w.print(Bonfire.format("listaction", arg));
	}
}
