// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara

package bonfire;

import java.io.*;
import java.util.*;
import com.objectspace.jgl.*;

public class NoteorQuestion {

	public static final int T_NOTE = 1;
	public static final int T_QUESTION = 2;

	int type = 0;
	int num;
	String text;
	Definition mydef;

	static SList notes = new SList();
	static SList questions = new SList();

	static int numnotes = 1;
	static int numquestions = 1;

	public NoteorQuestion(int a_type, String s, Definition def) {
		type = a_type;
		text = s;
		mydef = def;
		if (type == T_NOTE) {
			notes.add(this);
			num = numnotes++;
		} else {
			questions.add(this);
			num = numquestions++;
		}
	}

	public int getType() {
		return type;
	}

	public int getNum() {
		return num;
	}

	public void dumpHTMLSee(PrintWriter w) {
		Object args[] = { ((type==T_NOTE)?"note":"question")+num,
						  ((type==T_NOTE)?"Note ":"Question ")+num };
		w.println(Bonfire.format("noqsee", args));
	}

	public void dumpHTML(PrintWriter w) {
		Object args[] = { ((type==T_NOTE)?"note":"question")+num,
						  text,
		                  mydef.getName() };
		w.println(Bonfire.format("noqlist", args));
	}

	public static void dumpNotesList(PrintWriter w) {
		dumpList(notes.begin(), w);
	}

	public static void dumpQuestionsList(PrintWriter w) {
		dumpList(questions.begin(), w);
	}
		
	static void dumpList(SListIterator it, PrintWriter w) {
		while (!it.atEnd()) {
			((NoteorQuestion)it.get()).dumpHTML(w);
			it.advance();
		}
	}

}
