/* Generated By:JJTree: Do not edit this line. ORList.java */
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 170299 KH add *DTD methods after scema *HTML

package bonfire;

import java.io.*;
import com.objectspace.jgl.*;

/** Class that contains a disjunction of subexpressions.
 *
 *  @see ANDList
 *  @see Expr
 */ 
public class ORList extends BNFParserListNode {

	public static final int TYPE = 6;

	protected static ORList current = null;

	protected String attrname = "";

	protected int ornum = 1;

	public ORList(int id) {
		super(id);
	}

	public ORList(BNFParser p, int id) {
		super(p, id);
	}

	public int getTYPE() {
		return TYPE;
	}

	/** Useless debugging function. Please ignore.
	 *
	 *  @param w PrintWriter to write useless debugging message to
	 */
	public void dumpASCII(PrintWriter w) {
		DListIterator it=items.begin();
		((BNFParserNode)it.get()).dumpASCII(w);
		it.advance();
		for ( ; !it.atEnd(); it.advance()) {
			w.print(" | ");
			((BNFParserNode)it.get()).dumpASCII(w);
		}
	}

	/** Write HTML part of this fragment.
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpHTML(PrintWriter w) {
		if (parent instanceof ANDList) w.print("( ");
		DListIterator it=items.begin();
		((BNFParserNode)it.get()).dumpHTML(w);
		it.advance();
		for ( ; !it.atEnd(); it.advance()) {
			w.print(" | ");
			((BNFParserNode)it.get()).dumpHTML(w);
		}
		if (parent instanceof ANDList) w.print(") ");
	}

	/** Write DTD part of this fragment.
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpDTD(PrintWriter w) {
		if (parent instanceof ANDList) w.print("( ");
		DListIterator it=items.begin();
		((BNFParserNode)it.get()).dumpDTD(w);
		it.advance();
		for ( ; !it.atEnd(); it.advance()) {
			w.print(" | ");
			((BNFParserNode)it.get()).dumpDTD(w);
		}
		if (parent instanceof ANDList) w.print(") ");
	}

	/** Pick out all non-terminals that appear alone in a "branch" of this
	 *	disjunction and put them in a list.
	 *
	 *  @param l List to add single non-terms to
	 */
	public void findSingleNonTerms(SList l) {
		for (DListIterator it=items.begin(); !it.atEnd(); it.advance())
			if (it.get() instanceof NonTerminal) {
				Definition d = BNFParser.getDefinition(((NonTerminal)it.get()).getName());
				if (d != null) l.add(d);
			}
	}

	/** Generate attributes for this fragment. This function creates some
	 *  attributes itself (on toplevel, for single nonterms), but generally
	 *  passes the call on to its parts. It then returns the set union of all
	 *  attribute sets, thus reducing the size of the list and making it more
	 *  usable.
	 *
	 *  @param def Definition that called the function in the first place
	 *  @param env Description of the "history" of this call in terms of the constants defined in BNFParserNode
	 *  @param toplevel True, if this fragment is on the first level of a definition's tree.
	 *  @return Set union of generated attributes of all branches of this disjunction
	 *  @see ORList#setunion
	 *  @see BNFParserNode#OPTIONAL_F
	 *  @see BNFParserNode#ONEORMORE_F
	 *  @see BNFParserNode#ZEROORMORE_F
	 *  @see BNFParserNode#OR_F
	 */
	public DList generateAttributes(Definition def, int env, boolean toplevel) {
		if (current == null) {
			if (Definition.getCurrentORList() == null) {
				Definition.setCurrentORList(this);
				ornum = 1;
			} else
				ornum = Definition.getCurrentORList().ornum+1;
			attrname = "ORChoice"+ornum;
		} else {
			ornum = 1;
			attrname = current.attrname+"_"+ornum;
		}
		DList attrlist = new DList();
		DList _tmplist = new DList();
		_tmplist.add(new IntegerAttribute(attrname, this));
		attrlist.add(_tmplist);
		/*		if (toplevel) {
				DList terms = new DList();
				DList nonterms = new DList();
				// Find NonTerms
				for (DListIterator it = items.begin(); !it.atEnd(); it.advance()) {
				current = this;
				BNFParserNode n = (BNFParserNode)it.get();
				attrlist.add(n.generateAttributes(def, env | OR_F, false));
				current = null;
				}
				} else {*/
		for (DListIterator it = items.begin(); !it.atEnd(); it.advance()) {
			ORList oldcurrent = current;
			current = this;
			BNFParserNode n = (BNFParserNode)it.get();
			attrlist.add(n.generateAttributes(def, env | OR_F, false));
			oldcurrent = current;
		}
			//}
		return setunion(attrlist);
	}

	/** Write parser part of this fragment.
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpParser(PrintWriter w) {
		int cnum = 1;
		w.print("( ");
		DListIterator it=items.begin();		
		w.print("{ jjtThis.set"+attrname+"("+(cnum++)+"); } ");
		((BNFParserNode)it.get()).dumpParser(w);
		it.advance();
		for ( ; !it.atEnd(); it.advance()) {
			w.println();
			w.print("\t| ");
			w.print("{ jjtThis.set"+attrname+"("+(cnum++)+"); } ");
			((BNFParserNode)it.get()).dumpParser(w);
		}
		w.print(") ");
	}
  
	/** Build the set union of lists of attributes. If attributes are deleted,
	 *  the expressions these attributes belong to get pointers to the "master
	 *  copy".
	 *
	 *  @param sets List of Lists of attibutes (DList)
	 *  @return flat list of set union of all attribute lists
	 *  @see ClassAttribute#equals
	 */
	public DList setunion(DList sets) {
		DList reslist = new DList();
		DListIterator setsit = sets.begin();
		while(!setsit.atEnd()) {
			DList currset = (DList)setsit.get();
			setsit.advance();
			if (setsit.atEnd()) {
				for (DListIterator it=currset.begin(); !it.atEnd(); it.advance())
					reslist.add(it.get());
				continue;
			}
			for (DListIterator csit=currset.begin(); !csit.atEnd(); csit.advance()) {
				ClassAttribute currattr = (ClassAttribute)csit.get();
				DListIterator nextsetit = (DListIterator)setsit.clone();
				while (!nextsetit.atEnd()) {
					DList nextset = (DList)nextsetit.get();
					DListIterator nsit=nextset.begin();
					boolean goon = true;
					while (goon) {
						ClassAttribute nextattr = (ClassAttribute)nsit.get();
						if (nextattr.equals(currattr)) {
							BNFParserNode n = nextattr.getOwner();
							n.setAttribute(currattr);
							nextset.remove(nextattr);						
							goon = false;
						} else {
							nsit.advance();
							goon = !nsit.atEnd(); 
						}
					}
					nextsetit.advance();
				}
				reslist.add(currattr);
			}
		}
		return reslist;
	}

	public void maketoString(PrintWriter w, int env) {
		w.println(Bonfire.format("switchhead", attrname));
		int cnum = 1;
		for (DListIterator it = items.begin(); !it.atEnd(); it.advance()) {
			w.println(Bonfire.format("casehead", String.valueOf(cnum++)));
			BNFParserNode node = (BNFParserNode)it.get();
			node.maketoString(w, env | OR_F);
			w.println(Bonfire.format("caseend"));
		}
		w.println(Bonfire.format("switchend"));
	}

	public static ORList getCurrent() {
		return current;
	}

	public static void setCurrent(ORList c) {
		current = c;
	}

}
