// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara

package bonfire;

import java.io.*;

/** Yes, I <i>know</i> there are no pointers in Java ...
 *  This is an attribute that stores an object (pointer!).
 *
 */
class PointerAttribute extends ClassAttribute {

	public static final int TYPE = -6;
		
	PointerAttribute(String n, BNFParserNode o) {
		super(n, o);
		typ = n;
	}

	public int getTYPE() {
		return TYPE;
	}

	//	public String getName() {
	//		return "_"+name;
	//	}

	public void dumpDeclaration(PrintWriter w) {
		dumpDeclaration(w, typ, name, "null");
	}

	public void dumpMethods(PrintWriter w, boolean intf) {
		dumpMethods(w, typ, name, intf);
	}

	public void dumpParseCode(PrintWriter w) {
		Object arg[] = { name, typ };
		w.print(Bonfire.format("pointerret", arg));
	}

}
