/* Generated By:JJTree: Do not edit this line. StructComment.java */
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 160299 KH add *DTD methods and *DTD attributes after scema *HTML (DUMMY)

package bonfire;

import java.lang.*;
import java.io.*;
import com.objectspace.jgl.*;

/** Strcutured Comment. At the moment this is either the definition of the
 *  package to put all the classes (including the parser) in, or the definition
 *  of the current section.
 */
public class StructComment extends BNFParserNode {

	public static final int TYPE = 8;

	/** Structured Comment is a package definition */
	public static final int PACKAGE = 1;
	/** Structured Comment is a section definition */
	public static final int SECTION = 2;
	/** Structured Comment is the name of the language */
	public static final int LANGNAME = 3;

	/** Stack of name parts, used to build tree-like structure of sections
	 */
	private static DList stack = new DList(); // a DList named stack ...

	/** Type of this comment, see constants */
	private int type = 0;
	private String name;
	private DList namelist = new DList();
	private StructComment next = null;

	public StructComment(int id) {
		super(id);
	}

	public StructComment(BNFParser p, int id) {
		super(p, id);
	}

	public int getTYPE() {
		return TYPE;
	}

	/** Set type of this structured comment.
	 *
	 *  @param t Type of this structured comment
	 *  @see StructComment#type
	 *  @see StructComment#PACKAGE
	 *  @see StructComment#SECTION
	 */
	public void setType(int t) {
		type = t;
		//System.err.println("setType("+t+")");
	}

	/** Set the successor of this section.
	 *
	 *  @param c Successor of this section
	 */
	public void setNext(StructComment c) {
		next = c;
	}

	/** Get name from tokens, set current section if necessary.
	 *	Called by parser, don't use!
	 */
	public void jjtClose() {
		super.jjtClose();
		
		Token t;
		switch(type) {
		case PACKAGE:
			t = first_token.next;
			String pname = "";
			String lastpart = "";
			while (t.next != last_token) {
				pname += t.image;
				lastpart = t.image;
				t = t.next;
			}
			Bonfire.setPackage(pname);
			Bonfire.setLastPathPart(lastpart);
			break;
		case SECTION:
			t = first_token.next;
			name = Terminal.deQuote(t.image);
			namelist.add(name);
			while (t != last_token) {
				t = t.next.next; // Punkt berspringen
				if (t != last_token) {
					String dname = Terminal.deQuote(t.image);
					name += "."+dname;
					namelist.add(dname);
				}
			}
			Bonfire.setCurrSection(this);
			break;
		case LANGNAME:
			name = new String(first_token.next.image);
			if (name.startsWith("\"")) name = name.substring(1, name.length()-1);
			Bonfire.setLangName(name);
			break;
		default:
			t = first_token;
			name = t.image;
			Object arg[] = { new Integer(type) };
			Bonfire.error("wrongtypecomm", arg);
			//System.err.println("jjtClose()");
		}
	}

	/** Write HTML for this section (never called for package).
	 *
	 *  @param w PrintWriter to write to
	 *  @param shortform If true, write in smaller print (for link-list)
	 */
	public void dumpHTML(PrintWriter w, boolean shortform, String filename) {
		if (shortform) {
			Object args[] = { name,
							  filename };
			w.println(Bonfire.format("scshort", args));
		} else {
			dumpHTMLComments(w);
			w.println(Bonfire.format("sclong", name));
		}
	}

	/** Write DTD for this section (never called for package).
	 *
	 *  @param w PrintWriter to write to
	 *  @param shortform If true, write in smaller print (for link-list)
	 */
	public void dumpDTD(PrintWriter w, boolean shortform, String filename) {
// DUMMY  
	}

	/** Write section-structure to HTML file.
	 *
	 *  @param w PrintWriter to write to
	 *  @param filename Name of the file the links are to point to
	 */
	public void dumpHeader(PrintWriter w, String filename) {
		DListIterator myit = namelist.begin();
		DListIterator stackit = stack.begin();
		String currname = new String();
		boolean goon = !(myit.atEnd() || stackit.atEnd());
		int chopcnt = 0;
		while (goon) {
			if (((String)myit.get()).equals((String)stackit.get())) {
				if (!myit.atBegin()) currname += "."+(String)myit.get();
				else currname += (String)myit.get();
				myit.advance();
				stackit.advance();
				goon = !(myit.atEnd() || stackit.atEnd());
			} else {
				while (!stackit.atEnd()) {
					DListIterator _it = (DListIterator)stackit.clone();
					stackit.advance();
					stack.remove(_it.get());
					chopcnt++;
					if (!stackit.atEnd()) w.println(Bonfire.format("levelup"));
				}
				goon = false;
			}
		}
		if ((!myit.atBegin()) && (chopcnt == 0))
			w.println(Bonfire.format("nextlevel"));
		else w.println("<br>");
		while (!myit.atEnd()) {
			if (!myit.atBegin()) currname += "."+(String)myit.get();
			else currname += (String)myit.get();
			Object arg[] = { filename, currname, (String)myit.get() };
			w.println(Bonfire.format("sclink", arg));
			stack.add((String)myit.get());
			myit.advance();
			if (!myit.atEnd()) w.println(Bonfire.format("nextlevel"));
		}
		if (next != null) next.dumpHeader(w, filename);
	}
}
