/* Generated By:JJTree: Do not edit this line. Terminal.java */
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 170299 KH add *DTD methods after scema *HTML

package bonfire;

import java.io.*;
import com.objectspace.jgl.*;

/** Terminal symbol. 
 *
 *
 */
public class Terminal extends BNFParserNode {

	public static final int TYPE = 7;

	String name, tname;
	
	public Terminal(int id) {
		super(id);
	}
	
	public Terminal(BNFParser p, int id) {
		super(p, id);
	}
	
	public int getTYPE() {
		return TYPE;
	}

	/** Get name from token, add terminal symbol object to parser's list.
	 *	Called by parser, don't use!
	 */
	public void jjtClose() {
		name = deQuote(first_token.image);
		BNFParser.addTerminal(name);
		tname = translateTerm(name);
	}
  
	/** Return useless debugging message.		
	 */	
	public String toString() {
		return "Terminal: "+name;
	}

	/** Return name of this terminal symbol.
	 *
	 *  @return Name of this terminal symbol
	 */
	public String getName() {
		return name;
	}

	/** Useless debugging function. Please ignore.
	 *
	 *  @param w PrintWriter to write useless debugging message to
	 */
	public void dumpASCII(PrintWriter w) {
		w.print(name);
	}
	
	/** Usually passes call on to resolve all non-terminals, but useless here.
	 *  It only prevents BNFParserNode (whose function would otherwise be
	 *  called) from printing an error message.
	 *
	 *  @param user Definition this terminal symbol belongs to
	 */
	public void resolve(Definition user, BNFParserNode paren) {
		
	}

	/** Generate attribute for this terminal symbol. Either a BooleanAttribute
	 *  (OR_F or OPTIONAL_F) or a CounterAttribute (ONE_OR_MORE_F or
	 *  ZERO_OR_MORE_F) is created.
	 *
	 *	@param def Definition this Terminal belongs to
	 *  @param env Description of the "history" of this call in terms of the constants defined in BNFParserNode
	 *  @param toplevel True, if this fragment is on the first level of a definition's tree.
	 *  @return List of generated attributes
	 *  @see BooleanAttribute
	 *  @see CounterAttribute
	 *  @see BNFParserNode#OPTIONAL_F
	 *  @see BNFParserNode#ONEORMORE_F
	 *  @see BNFParserNode#ZEROORMORE_F
	 *  @see BNFParserNode#OR_F
	 */
	public DList generateAttributes(Definition def, int env, boolean toplevel) {
		DList attrlist = new DList();
		if ((env & (ONEORMORE_F | ZEROORMORE_F)) != 0) {
			attr = new CounterAttribute(tname, this);
			//def.addAttribute(attr);
			attrlist.add(attr);
		} else if ((env & (OR_F | OPTIONAL_F)) != 0) {
			attr = new BooleanAttribute(tname, this);
			//def.addAttribute(attr);
			attrlist.add(attr);
		}
		return attrlist;
	}

	/** Write HTML for this terminal symbol.
	 *
	 *  @param w PintWriter to write to
	 */
	public void dumpHTML(PrintWriter w) {
		dumpHTMLNewLines(w);
		w.print(Bonfire.format("termpr", HTMLify(name, true)));
	}

	/** Write HTML for this terminal symbol.
	 *
	 *  @param w PintWriter to write to
	 */
	public void dumpDTD(PrintWriter w) {
//		dumpHTMLNewLines(w);
//    w.print("\n     ");
		w.print(Bonfire.format("dtdpr", name));
	}

	/** Write parser part for this terminal symbol
	 *
	 *  @param w PrintWriter to write to
	 */
	public void dumpParser(PrintWriter w) {
		w.print("<"+tname+">");
		//w.print("\""+name+"\"");
		if (attr != null) attr.dumpParseCode(w);
	}

	public void maketoString(PrintWriter w, int env) {
		if ((env & (ONEORMORE_F | ZEROORMORE_F)) != 0) {
			if (attr instanceof BooleanAttribute) {
				Object args[] = { attr.getName(),
								  name };
				w.print(Bonfire.format("termtsmoresingle", args));
			} else w.print(Bonfire.format("termts", name));
		} else if ((env & (OPTIONAL_F | OR_F)) != 0) {
			Object args[] = { attr.getName(),
							  name };
			w.print(Bonfire.format("termtsopt", args));
		} else w.print(Bonfire.format("termts", name));
	}

	/** Return a the argument stripped of quotes.
	 *
	 *  @param s String to de-quote
	 */
	public static String deQuote(String s) {
		if (s.startsWith("'") || s.startsWith("\""))
			return s.substring(1, s.length()-1);
		else return s;
	}

}
