// Java Resources
// This file is part of Bonfire
// (P) 1998 by Robert "I'll do it tomorrow!" Kosara, rkosara@ifs.tuwien.ac.at
// http://www.ifs.tuwien.ac.at/~rkosara
//
// 160299 KH add *DTD* resources after scema *BNF*
//        dtdbegin, dtdend

package bonfire.resources;

import java.util.*;

public class JavaRes extends java.util.ListResourceBundle {

	public Object[][] getContents() {
		return contents;
	}

	static Object[][] contents = {
		{ "javadocdefaultdir", "javadoc/" },
		{ "htmldocdefaultdir", "javadoc/" },
		{ "classcomment", "// Created by Bonfire, {0}\n"+
		  "// Do not edit.\n" },
		{ "namecomment", "// {0}" },
		{ "package", "package {0};\n" },
		{ "langparsernode", "import java.io.*;\n"+
		  "\n"+
		  "public class {0}ParserNode extends SimpleNode implements Serializable '{'\n"+
		  "\n"+
		  "\tpublic static final int TYPE = 0;\n"+
		  "\n"+
		  "\tpublic Token first_token = null, last_token = null;\n"+
		  "\n"+
		  "\tprivate boolean parsednode = false;\n"+
		  "\n"+
		  "\ttransient protected static int _hookindex = 0;\n"+
		  "\n"+
		  "\tpublic {0}ParserNode(int i) '{'\n"+
		  "\t\tsuper(i);\n"+
		  "\t}\n"+
		  "\n"+
		  "\tpublic {0}ParserNode({0}Parser p, int i) '{'\n"+
		  "\t\tsuper(p, i);\n"+
		  "\t}\n"+
		  "\n"+
		  "\tpublic int getTYPE() '{'\n"+
		  "\t\treturn TYPE;\n"+
		  "\t}"+
		  "\n"+
		  "\tpublic boolean isParsedNode() '{'\n"+
		  "\t\treturn parsednode;\n"+
		  "\t}"+
		  "\n"+
		  "\tpublic void jjtClose() '{'\n"+
		  "\t\tparsednode = true;\n"+
		  "\t\tsuper.jjtClose();\n"+
		  "\t}\n"+
		  "\n"+
		  "\tpublic String toString() '{'\n"+
		  "\t\treturn \"\";\n"+
		  "\t}\n\n"+
		  "\t/** Return next index for hooking up data. */\n"+
		  "\tpublic static int getDataHookIndex() '{'\n"+
		  "\t\treturn _hookindex++;\n"+
		  "\t}\n"+
		  "}" },
		{ "makefile", "# Makefile created by Bonfire, {0}\n"+
		  "# Do not edit.\n"+
		  "\n"+
		  "JAVAC = {5}\n"+
		  "JAVACC = javacc\n"+
		  "JJTREE = jjtree\n"+
		  "JAR = jar\n"+
		  "JAVADOC = javadoc\n"+
		  "\n"+
		  "all: {1}Parser.class\n"+
		  "\n"+
		  "{1}Parser.class: {1}Parser.java\n"+
		  "\t$(JAVAC) *.java\n"+
		  "\n"+
		  "{1}Parser.java: {1}Parser.jj\n"+
		  "\t$(JAVACC) {1}Parser.jj\n"+
		  "\n" },
		{ "makefile2", "{1}Parser.jj: {1}Parser.jjt\n"+
		  "\t$(JJTREE) {1}Parser.jjt\n"+
		  "\n"+
		  "{2}.jar: {1}Parser.class\n"+
		  "\trm -f {2}.jar\n"+
		  "\tcd ..; $(JAR) cf0 {3}/{2}.jar {3}/*.class\n"+
		  "\n"+
		  "jar: {2}.jar\n"+
		  "\n" },
		{ "makefile3", "doc: {1}Parser.class\n"+
		  "\t$(JAVADOC) -d {4} -private {2}\n"+
		  "\n"+
		  "clean:\n"+
		  "\trm -f *.class *.jar *.jj {1}Parser.java *~\n" },
		{ "index.html", "<html><head><title>EBNF for {0}</title></head>\n"+
		  "<frameset cols=\"*,3*\">\n"+
		  "\t<frameset rows=\"*,4*\">\n"+
		  "\t\t<frame src=\"{1}Struct.html\" scrolling=\"auto\" marginwidth=1>\n"+
		  "\t\t<frame src=\"{1}Links.html\" name=\"links\" scrolling=\"auto\" marginwidth=1>\n"+
		  "\t</frameset>\n"+
		  "\t<frame src=\"{1}BNF.html\" name=\"main\" scrolling=\"auto\" MARGINWIDTH=1>\n"+
		  "</frameset>\n"+
		  "</html>" },
		{ "structhead", "<html><head><title>EBNF-Structure for {0}</title></head>\n"+
		  //"<body bgcolor=\"#ffcc00\">"+
		  "<body bgcolor=\"white\">\n"+
		  "<h3>Structure of {0}</h3>" },
		{ "htmlend", "</body></html>" },
		{ "dtdend", "" },
		{ "structliststart", "<dir>" },//"<ul compact>" },
		{ "structlistend", "</dir>" },//"</ul>" },
		{ "linkhead", "<html><head><title>Links for {0}</title></head>\n"+
		  //w.println("<body bgcolor=\"#ffbb00\">");
		  "<body bgcolor=\"white\">" },
		{ "bnfhead", "<html><head><title>EBNF for {0}</title></head>\n"+
		  "<body bgcolor=\"white\">\n"+
		  "<center><h1>{0}</h1></center>\n"+
		  "This file was automatically created by "+
		  "<a href=\"http://www.ifs.tuwien.ac.at/~rkosara/Bonfire/index.html\" target=\"_top\">"+
		  "Bonfire</a> on {1}. Language consists of "+
		  "{2} NonTerminals and {3} different Terminals. "+
		  "Starting NonTerminal is <a href=\"#{4}\">{4}</a>.\n" },
		{ "dtdhead", "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n\n"+
      "<!-- {0}.dtd -->\n"+
		  "<!-- This file was automatically created by Bonfire on {1} -->\n"+
      "<!-- Language consists of {2} NonTerminals and {3} different Terminals. -->\n\n"+
      "<!-- Starting NonTerminal is {4} -->\n\n"+
      "<!ELEMENT {0} ({4}*)>\n\n" },
		{ "bnfdefs", "<hr><a name=\"defs\"></a><table border width=\"100%\"><tr><th>Definitions</th><th><a href=\"#xref\">XRef</a></th><th><a href=\"#notes\">Notes</a></th><th><a href=\"#questions\">Questions</a></th></tr></table>" },
		{ "otherroots", " Other possible roots are " },
		{ "rootlist", "<a href=\"#{0}\">{0}</a>" },
		//		{ "bnflisthead", "<p>" },
		//		{ "bnflistend", "" },
		{ "xrefhead", "<hr><a name=\"xref\"></a><table border width=\"100%\"><tr><th><a href=\"#defs\">Definitions</a></th><th>XRef</th><th><a href=\"#notes\">Notes</a></th><th><a href=\"#questions\">Questions</a></th></tr></table>\n"+
		  "<h1>Cross-Reference Section</h1>\n"+
		  "<dl>" },
		{ "xrefsecend", "</dl>" },
		{ "noteshead", "<hr><a name=\"notes\"></a><table border width=\"100%\"><tr><th><a href=\"#defs\">Definitions</a></th><th><a href=\"#xref\">XRef</a></th><th>Notes</th><th><a href=\"#questions\">Questions</a></th></tr></table>\n"+
		  "<h1>Notes</h1>\n"+
		"<ol>"},
		{ "notesend", "</ol>" },
		{ "questionshead", "<hr><a name=\"questions\"></a><table border width=\"100%\"><tr><th><a href=\"#defs\">Definitions</a></th><th><a href=\"#xref\">XRef</a></th><th><a href=\"#notes\">Notes</a></th><th>Questions</th></tr></table>\n"+
		  "<h1>Questions</h1>\n"+
		  "<ol>" },
		{ "questionsend", "</ol>" },
		// NonTerminal
		{ "nontermdef", "<a href=\"#{0}\">&lt;{1}&gt;</a>" },
		{ "nontermdtd", "{0}" },
		{ "nontermnondef", "&lt;{0}&gt" },
		{ "nontermnondtd", "{0}" },
		{ "ntts", "\t\ts += _{0}.toString()+'' '';" },
		{ "nttsopt", "\t\tif (_{0} != null) s += _{0}.toString()+'' '';\n" },
		{ "nttsmoresingle", "\t\tfor (DListIterator it=_{0}_list.begin(); !it.atEnd(); it.advance())\n"+
		  "\t\t\ts += (({1}ParserNode)it.get()).toString()+'' '';\n" },
		{ "nttsmoremulti", "\t\t\ts += (({1}ParserNode){2}.get()).toString()+\'' '';\n"+
		  "\t\t\t{2}.advance();" },
		// StructComment
		{ "scshort", "<hr><a name=\"{0}\" href=\"{1}#{0}\" target=\"main\"><h3>{0}</h3></a>" },
		{ "sclong", "<dt><hr><a name=\"{0}\"><h2>{0}</h2></a>" },
		{ "levelup", "</dir>" },
		{ "nextlevel", "<dir>" },
		{ "sclink", "<a href=\"{0}#{1}\" target=\"links\">{2}</a>" },
		// Terminal
		{ "termpr", "<b>{0}</b>" },
 		{ "dtdpr", "\"{0}\"" },
		{ "termts", "\t\ts += \"{0} \";" },
		{ "termtsopt", "\t\tif (_{0}) s += \"{1} \";" },
		{ "termtsmoresingle", "\t\tfor (int i=0; i<_{0}; i++) s += \"{1} \";" },
		// Definition
		{ "parserbegin", "options '{'\n"+
		  "\tLOOKAHEAD = 2147483647; // infinite\n"+
		  "\tMULTI = true;\n"+
		  "\tFORCE_LA_CHECK = true;\n"+
		  "\tNODE_SCOPE_HOOK = true;\n"+
		  "\tNODE_PREFIX = \"\";\n"+
		  "}\n"+
		  "\n"+
		  "PARSER_BEGIN({0}Parser)\n"+
		  "\n" },
		{ "parsermain", "import java.io.*;\n"+
		  "\n"+
		  "public class {0}Parser '{'\n"+
		  "\n"+
		  "\tpublic static void main(String args[]) throws ParseException '{'\n"+
		  "\t\tInputStream fin = (InputStream)System.in;\n"+
		  "\t\tif (args.length == 1)\n"+
		  "\t\t\ttry '{'\n"+
		  "\t\t\t\tfin = new FileInputStream(args[0]);\n"+
		  "\t\t\t} catch (FileNotFoundException e) '{'\n"+
		  "\t\t\t\tSystem.err.println(\"{0}Parser Error: File \\\"\"+args[0]+\"\\\" not found!\");\n"+
		  "\t\t\t\tSystem.exit(1);\n"+
		  "\t\t\t}\n"+
		  "\t\t{0}Parser parser = new {0}Parser(fin);\n"+
		  "\t\t{0}ParserNode n = ({0}ParserNode)parser.{1}();\n"+
		  "\t\tSystem.out.println(n.toString());\n"+
		  "\t}\n"+
		  "\n"+
		  "\tstatic void jjtreeOpenNodeScope(Node n) '{'\n"+
		  "\t\t(({0}ParserNode)n).first_token = getToken(1);\n"+
		  "\t}\n"+
		  "\n"+
		  "\tstatic void jjtreeCloseNodeScope(Node n) '{'\n"+
		  "\t\t(({0}ParserNode)n).last_token = getToken(0);\n"+
		  "\t}\n"+
		  "\n"+
		  "}\n"+
		  "\n"+
		  "PARSER_END({0}Parser)\n"+
		  "\n"+
		  "SKIP :\n"+
		  "'{'\n"+
		  "  \" \"\n"+
		  "| \"\\t\"\n"+
		  "| \"\\n\"\n"+
		  "| \"\\r\"\n"+
		  "}\n"+
		  "\n"+
		  "TOKEN :\n"+
		  "'{'" },
		{ "parsertokens", "\t| <#LETTER: [\"a\"-\"z\", \"A\"-\"Z\"]>\n"+
		  "\t| <#DIGIT: [\"0\"-\"9\"]>\n"+
		  "\t| <#SPECIAL: [\"_\", \"-\", \".\", \"$\"]>\n"+
		  "\t| <#STRCHAR: (<LETTER>|<DIGIT>|<SPECIAL>)>\n"+
		  "\t| <INTEGER: ((<DIGIT>)+)>\n"+
		  "\t| <FLOAT: (((<DIGIT>)*)\".\"((<DIGIT>)*))>\n"+
		  "\t| <STRING: ((\"_\"|<LETTER>)(<STRCHAR>)*)>\n"+
		  "\t| <DATE: (<DIGIT><DIGIT>\" \"<LETTER><LETTER><LETTER>\" \"<DIGIT><DIGIT><DIGIT><DIGIT>\" \"<DIGIT><DIGIT>\":\"<DIGIT><DIGIT>\":\"<DIGIT><DIGIT>)>\n"+
		  "}\n" },
		{ "toStringhead", "\tpublic String toString() {\n"+
		  "\t\tString s = \"\";" },
		{ "toStringend", "\n\t\treturn s;\n"+
		  "\t}" },
		{ "shorthtmlentry", "<li><a href=\"{0}BNF.html#{1}\" target=\"main\">"+
		  "{2}{1}</a></li>" },
		{ "predefined", "<table border=0 cellspacing=0 cellpadding=5 width=\"100%\"><tr><td bgcolor=\"#CCCCCC\">"+
		  "<dl><dt><a href=\"#xref{0}\">&lt;%{0}"+
		  "&gt;</a> ::= <a href=\"{3}{1}.{2}.html\">&laquo;?&iquest;?&raquo;</a>"+
		  "<dd><i>Predefined Non-Terminal</i></dd></dl></td></tr></table>" },
		{ "predef-nolink", "<table border=0 cellspacing=0 cellpadding=5 width=\"100%\"><tr><td bgcolor=\"#CCCCCC\">"+
		  "<dl><dt><a href=\"#xref{0}\">&lt;%{0}&gt;</a> ::="+
		  "<dd><i>Predefined Non-Terminal</i></dd></dl></td></tr></table>" },
		{ "predefineddtd", "<!ELEMENT {0} " },
		{ "predefdtd-nolink", "<!ELEMENT {0} "},
		{ "defhtmlbegin", "<table border=0 cellspacing=0 cellpadding=5 width=\"100%\"><tr><td bgcolor=\"#CCCCCC\">"+
		  "<dl><dt><a href=\"#xref{0}\">&lt;{0}"+
		  "&gt;</a> ::= <a href=\"{3}{1}.{2}.html\">&laquo;?&iquest;?&raquo;</a>"+
		  "<dd>" },
		{ "defdtdbegin", "<!ELEMENT {0} " },
		{ "defhtmlbeg-nolink", "<table border=0 cellspacing=0 cellpadding=5 width=\"100%\"><tr><td bgcolor=\"#CCCCCC\">"+
		  "<dl><dt><a href=\"#xref{0}\">&lt;{0}&gt;</a> ::="+
		  "<dd>" },
		{ "defdtdbeg-nolink", "<!ELEMENT {0} " },
		{ "defhtmlend", "</dd></dl></td></tr></table>" },
		{ "defdtdend", ">\n\n" },
		{ "defanchor", "<a name=\"{0}\"</a>" },
		{ "xrefdef", "<dt><a name=\"xref{0}\" href=\"#{0}\">&lt;"+
		  "{1}{0}&gt;</a>" },
		{ "dtdrefdef", "{0}" },
		{ "usedin", "is used in </dt><dd>" },
		{ "dtdref", " (" },
		{ "xrefend", "</dd>" },
		{ "dtdrefend", ")*>\n" +
      "<!ATTLIST {0}\n"+
      "  id ID #REQUIRED" },
		{ "neverused", " was defined but never used.</dd>" },
		{ "classfileheader", "import com.objectspace.jgl.*;\n"+
		  "import java.beans.*;\n"+
		  "import java.util.*;\n"+
		  "import java.text.*;\n"+
		  "\n" },
		{ "intfdecl", "/** Interface defintion for &lt;{0}&gt;.<br>\n"+
		  " *\n"+
		  " * See\t<a href=\"../{1}BNF.html#{0}\">{0}</a>\n"+
		  " */\n"+
		  "public interface {2} " },
		{ "extends", "extends " },
		{ "classdecl", "/** Class defintion for &lt;{0}&gt.\n"+
		  /*" *\n"+
			" * see <a href=\"../{1}BNF.html#{0}\">{0}</a>\n"+*/
		  " */\n"+
		  "public class {2} extends " },
		{ "typedecl", " '{'\n"+
		  "\n"+
		  "\t /** Type of this node. */\n"+
		  "\tpublic static final int TYPE = {0};" },
		{ "hookdecl","\ttransient protected Vector _hookeddata = new Vector();" },
		{ "constructor", "\t{0}(int i) '{'\n"+
		  "\t\tsuper(i);\n"+
		  "\t}" },
		{ "gettype", "\t/** This method returns the type number of this object.\n"+
		  "\t*/\n"+
		  "\tpublic int getTYPE()" },
		{ "gettypebody", " {\n"+
		  "\t\treturn TYPE;\n"+
		  "\t}" },
		{ "sethd", "\t/** Hook data to object. */\n"+
		  "\tpublic void setHookedData(int index, Object data)" },
		{ "sethdbody", " {\n"+
		  "\t\tif (_hookeddata.size() <= index) _hookeddata.setSize(index+1);\n"+
		  "\t\t_hookeddata.setElementAt(data, index);\n"+
		  "\t}" },
		{ "gethd", "\t/** Get data hooked to object. */\n"+
		  "\tpublic Object getHookedData(int index)" },
		{ "gethdbody", " {\n"+
		  "\t\tif (index >= _hookeddata.size()) return null;\n"+
		  "\t\t\telse return _hookeddata.elementAt(index);\n"+
		  "\t}" },
		{ "jjtclose", "\tpublic void jjtClose() {" },
		{ "jjtcstring", "\t\t_String = first_token.image;" },
		{ "jjtcint", "\t\t_Int = Integer.parseInt(first_token.image);" },
		{ "jjtcdouble", "\t\t_Double = Double.valueOf(first_token.image).doubleValue();" },
		{ "jjtcdate", "\t\ttry {\n"+
		  "\t\t\t_Date = DateFormat.getDateTimeInstance().parse(first_token.image);\n"+
		  "\t\t} catch (java.text.ParseException e) {\n"+
		  "\t\t\tSystem.out.println(\"exception: \" + e.getMessage());\n"+
		  "\t\t\te.printStackTrace();\n"+
		  "\t\t}\n" },
		{ "jjtcend", "\t\tsuper.jjtClose();\n"+
		  "\t}" },		  
		{ "toStringheadpredef", "\tpublic String toString() {\n" },
		{ "deftsstring", "\t\treturn new String(_String);\n"+
		  "\t}\n" },
		{ "deftsint", "\t\treturn String.valueOf(_Int);\n"+
		  "\t}\n" },
		{ "deftsdouble", "\t\treturn Double.toString(_Double);\n"+
		  "\t}\n" },
		{ "deftsdate", "\t\tSimpleDateFormat formatter = new SimpleDateFormat(\"dd-MMM-yyyy HH:mm:ss\");\n"+
		  "\t\treturn formatter.format(_Date);\n"+
		  "\t}\n" },
		// ORList
		{ "switchhead", "\t\tswitch(_{0}) '{'" },
		{ "casehead", "\t\tcase {0}:" },
		{ "caseend", "\t\tbreak;" },
		{ "switchend", "\t\t}" },
 		// BooleanAttribute
		{ "setboolean", "'{' jjtThis.set{0}(true); } " },
		// CounterAttribute
		{ "countermethods", "\n"+
 		  "\t/** This method increments the value of {0}. */\n"+
	 	  "\tpublic int inc{0}() '{'\n"+
		  "\t\tset{0}(_{0}+1);\n"+
		  "\t\treturn _{0};\n"+
		  "\t}\n"+
		  "\n"+
 		  "\t/** This method decrements the value of {0}. */\n"+
 	 	  "\tpublic int dec{0}() '{'\n"+
		  "\t\tset{0}(_{0}-1);\n"+
		  "\t\treturn _{0};\n"+
		  "\t}\n" },
		{ "inccounter", "'{' jjtThis.inc{0}(); } " },
		// PassThrougAttribute
		{ "passthroughret", "{ return n; } " },
		// PointerAttribute
		{ "pointerret", "'{' jjtThis.set{0}(({1}) n); } " },
		{ "classattrdecl", "\t/** Variable for storing {0}. */\n"+
		  "\tprotected {1} _{0}" },
		{ "classattrlistenerdecl", "\t/** Variables for storing {0}''s listeners. */\n"+
		  "\ttransient protected SList _{0}listeners = new SList();" },
		{ "classattrget", "\n"+
		  "\t/** This method returns the value of attribute {0}. */\n"+
		  "\tpublic {1} get{0}()" },
		{ "classattrreturn", " '{'\n"+
		  "\t\treturn _{0};\n"+
		  "\t}" },
		{ "classattrset", "\t/** This method sets the value of attribute {0}. */\n"+
		  "\tpublic void set{0}({1} val)" },
		{ "classattrnocast", "'{'\n"+
		  "\t\tPropertyChangeEvent p = new PropertyChangeEvent(this, \"{0}\", _{0}, val);" },
		{ "classattrcast", "'{'\n"+
		  "\t\tPropertyChangeEvent p = new PropertyChangeEvent(this, \"{0}\", new {1}(_{0}), new {1}(val));" },
		{ "classattrsetbody", "\t\t_{0} = val;\n"+
		  "\t\tfor (SListIterator it = _{0}listeners.begin(); !it.atEnd(); it.advance())\n"+
		  "\t\t\t((PropertyChangeListener)it.get()).propertyChange(p);\n"+ 
		  "\t}" },
		{ "classattraddlistener", "\t/** This method adds a listener for attribute {0}. */\n"+
		  "\tpublic void add{0}Listener(PropertyChangeListener l)" },
		{ "classattralbody", " '{'\n"+
		  "\t\t_{0}listeners.add(l);\n"+
		  "\t}" },
		{ "classattrremlistener", "\t/** This method removes a listener for attribute {0}. */\n"+
		  "\tpublic int remove{0}Listener(PropertyChangeListener l)" },
		{ "classattrrlbody", " '{'\n"+
		  "\t\treturn _{0}listeners.remove(l);\n"+
		  "\t}" },
		// ListAttribute
		{ "listdecl", "\tprotected DList _{0}_list = new DList();" },
		{ "listadd", "\tpublic void add{0}({1} val)" },
		{ "listaddbody", " '{'\n"+
		  "\t\t_{0}_list.add(val);\n"+
		  "\t}" },
		{ "listrem", "\tpublic int remove{0}({1} val)" },
		{ "listrembody", " '{'\n"+
		  "\t\treturn _{0}_list.remove(val);\n"+
		  "\t}" },
		{ "listgetfirst", "\tpublic DListIterator getFirst{0}It()" },
		{ "listgetfirstbody", " '{'\n"+
		  "\t\treturn _{0}_list.begin();\n"+
		  "\t}" },
		{ "listaction", "'{' jjtThis.add{0}(({1}) n); } " },
		// NoteorQuestion
		{ "noqsee", "<a href=\"#{0}\">{1}</a>" },
		{ "noqlist", "<li><a name=\"{0}\"></a>{1} (in <a href=\"#{2}\">&lt;{2}&gt;</a>)</li>\n" },
		// Expr
		{ "exprtsbeg", "\t\twhile (!{0}.atEnd()) '{'" },
		{ "exprtsend", "\t\t}" },
		// ANDList
		{ "alitdecl", "\t\tDListIterator {0} = _{1}_list.begin();" }
	};   

}  
