//----------------------------------------------------------------------------
//
// Module:      SimpleTextDefine.java      
//
// Description: Static defines for all SimpleSelect classes
//
// Author:      Karl Moss
//
// Copyright:   (C) 1996 Karl Moss.  All rights reserved.
//              You may study, use, modify and distribute this example
//              for any purpose, provided that this copyright notice
//              appears in all copies.  This example is provided WITHOUT
//              WARRANTY either expressed or implied.
//
// Modification: 31.3.99 KH
//  * Modified default NUMBER-type to LONG
//  * Added *Long Methods using *int and and Type.INTEGER pattern
//
//----------------------------------------------------------------------------

package jdbc.SimpleText;

import java.sql.*;

public class SimpleTextDefine
{
    //------------------------------------------------------------------------
    // Version numbers
    //------------------------------------------------------------------------

    public final static int MAJOR_VERSION = 1;
    public final static int MINOR_VERSION = 0001;

    //------------------------------------------------------------------------
    // Maximums
    //------------------------------------------------------------------------


    public final static int MAX_COLUMN_NAME_LEN        = 18;
    public final static int MAX_COLUMNS_IN_TABLE    = 80;
    public final static int MAX_CATALOG_NAME_LEN    = 128;
    public final static int MAX_TABLE_NAME_LEN        = 40;
    public final static int MAX_VARCHAR_LEN            = 5120;
    public final static int MAX_INTEGER_LEN            = 20;
    public final static int MAX_VARBINARY_LEN        = 1048576;

    //------------------------------------------------------------------------
    // SQL statement types
    //------------------------------------------------------------------------

    public final static int SQL_SELECT    = 1;
    public final static int SQL_INSERT    = 2;
    public final static int SQL_CREATE    = 3;
    public final static int SQL_DROP    = 4;
    public final static int SQL_DELETE    = 5;
    public final static int SQL_UPDATE    = 6;

    //------------------------------------------------------------------------
    // Column name prefixes indicating type
    //------------------------------------------------------------------------

    public final static String COL_TYPE_NUMBER = "#";
    public final static String COL_TYPE_BINARY = "@";

    //------------------------------------------------------------------------
    // Record flags
    //------------------------------------------------------------------------
    public final static char REC_TYPE_DELETED = '$';

    //------------------------------------------------------------------------
    // File extensions
    //------------------------------------------------------------------------

    public final static String DATA_FILE_EXT    = ".SDF";
    public final static String BINARY_FILE_EXT    = ".SBF";
} 

