package test.encode;

import java.io.*;
import asgaard.utils.encode.*;

public class SniffFileInputStream extends FileInputStream {

  private HexEncOutputStream snif = new HexEncOutputStream( );
  private FileWriter snifout;
  private String memo;
  private int counter = 0;
  int i;

  public SniffFileInputStream(String file, String filename, String memo ) throws IOException {
    super( file );
    this.memo = memo;
    snifout = new FileWriter( filename );
    writeln();
  }

  public void writeln() throws IOException {
    if (snifout != null)
      snifout.write( memo +"(" + String.valueOf(counter) + ")" + snif.readBuffer() + "\n" );
    counter++;
  }

  public int read() throws IOException {
    i = super.read();
    snif.write( i );
    return i;
  }
  public int read(byte b[]) throws IOException {
    int l = 0;
    for (int j=0; j<b.length; j++)
      if (read() > 0) {
        b[j] = (byte) i;
        l++;
      } else
        break;
    return l;
  }
  public int read (byte b[], int off, int len) throws IOException {
    int l = 0;
    int w = 0;
    for (int k=0; k<off; k++)
      if (super.read() > 0)
        snif.write( (int) '-' );
      else
        break;
    for (int j=0; j<len; j++)
      if (read() > 0) {
        b[j] = (byte) i;
        l++;
      } else
        break;
    return l;
  }
  public void close() throws IOException {
    super.close();
    writeln();
    snifout.close();
  }
}
