package test.encode;

import java.io.*;
import asgaard.utils.encode.*;

public class SniffObjectOutputStream extends ObjectOutputStream {

  private HexEncOutputStream snif = new HexEncOutputStream( );
  private FileWriter snifout;
  private String memo;
  private int counter = 0;

  public SniffObjectOutputStream(OutputStream out, String filename, String memo ) throws IOException {
    super( out );
    this.memo = memo;
    snifout = new FileWriter( filename );
    writeln();
  }

  public void writeln() throws IOException {
    if (snifout != null)
      snifout.write( memo +"(" + String.valueOf(counter) + ")" + snif.readBuffer() + "\n" );
    counter++;
  }

  public void write(int b) throws IOException {
    snif.write( b );
    super.write( b );
  }
  public void write(byte b[]) throws IOException {
    snif.write( b );
    super.write( b );
  }
  public void write(byte b[], int off, int len) throws IOException {
    snif.write( b, off, len );
    super.write( b, off, len );
  }
  public void close() throws IOException {
    super.close();
    writeln();
    snifout.close();
  }
}