package test.xml;

import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import java.io.*;

public class ClassParser {

  private FileWriter classWriter = null;
  private FileWriter dtdWriter = null;

  public static void main (String args[]) throws Exception {
    Parser ps = new Parser("Java Class & DTD Creator");
    ClassParser app = new ClassParser();
    app.doit(ps.readStream(new FileInputStream("p:/Asgaard/src/test/xml/ClassSpec.xml")));
  }

  private void doit(Document doc) throws Exception {
    // Get the name of the root-element
    NodeList root = doc.getElementsByTagName("spec");
    Element o = (Element) root.item( 0 );
    String packageName = o.getAttribute("name");
    // Get the list with all class-definitions
    NodeList classList = doc.getElementsByTagName("class");
    String classNames = "#PCDATA";
    for (int i=0;i<classList.getLength();i++) {
      Element c = (Element) classList.item( i );
      classNames += " | " + c.getAttribute("name");
    }
    NodeList reflectList = doc.getElementsByTagName("reflect");
    for (int h=0;h<reflectList.getLength();h++) {
      Element r = (Element) reflectList.item( h );
      classNames += " | " + r.getAttribute("name");
    }
    // Writing the Header of the DTD file
    dtdWriter = new FileWriter(packageName+".dtd");
    dtdWriter.write("<?xml version=\"1.0\"?>\n");
    dtdWriter.write("<!DOCTYPE "+packageName+" [\n");
    dtdWriter.write("<!ELEMENT "+packageName+" ("+classNames+")*>\n");
    // Create all java-class-files
    for (int i=0;i<classList.getLength();i++)
      if (classList.item( i ).getNodeType() == Node.ELEMENT_NODE) {
        Element c = (Element) classList.item( i );
        String className = c.getAttribute("name");
        // produce a new java-class-file
        classWriter = new FileWriter(className+".java");
        classWriter.write("package "+packageName+";\n\n");
        classWriter.write("public class "+className+" {\n\n");
        // produce the definition-java-code
        NodeList attrList = c.getElementsByTagName("attr");
        for (int j=0;j<attrList.getLength();j++)
          if (attrList.item( j ).getNodeType() == Node.ELEMENT_NODE) {
            Element a = (Element) attrList.item( j );
            classWriter.write("  " + a.getAttribute("modifyer") + " " +
                a.getAttribute("type") + " " +
                a.getAttribute("name") + "; \n");
          }
        classWriter.write("\n");
        // addes element-definitions for the class to the dtd-file
        NodeList methodList = c.getElementsByTagName("method");
        String methodNames = "#PCDATA";
        for (int k=0;k<methodList.getLength();k++)
          if (methodList.item( k ).getNodeType() == Node.ELEMENT_NODE) {
            Element m = (Element) methodList.item( k );
            if (m.getAttribute("modifyer").equalsIgnoreCase("PUBLIC"))
              methodNames += " | " + m.getAttribute("name");
          }
        dtdWriter.write("<!ELEMENT "+className+" ("+methodNames+")*>\n");
        // produces the method-java-code
        for (int k=0;k<methodList.getLength();k++)
          if (methodList.item( k ).getNodeType() == Node.ELEMENT_NODE) {
            Element m = (Element) methodList.item( k );
            classWriter.write("  " + m.getAttribute("modifyer") + " " +
                m.getAttribute("type") + " " +
                m.getAttribute("name") + "(String content) { \n");
            // produces the method-body-code ot of the tag-content
            NodeList codeList = m.getChildNodes();
            for (int l=0;l<codeList.getLength();l++)
              if (codeList.item( l ).getNodeType() == Node.TEXT_NODE) {
                classWriter.write( codeList.item( l ).getNodeValue());
              }
            classWriter.write("\n  }");
            // addes element-definitions for the method to the dtd-file
            if (m.getAttribute("modifyer").equalsIgnoreCase("PUBLIC"))
              dtdWriter.write("<!ELEMENT "+m.getAttribute("name")+" (#CDATA)>\n");
          }
        classWriter.write("\n}");
        classWriter.close();
      }
    // adds element-definitions for reflected classes to the dtd-file
    for (int h=0;h<reflectList.getLength();h++) {
      Element r = (Element) reflectList.item( h );
      dtdWriter.write("<!ELEMENT "+r.getAttribute("synonym")+" EMPTY>\n");
    }
    // Close
    dtdWriter.write("]>");
    dtdWriter.close();
  }
}
